/// AqEmuDlg.cpp : implementation file by Kenny Millar
// (C) Copyright 2000 by Kenny Millar
//
// Sorry, but this code is not freeware.
// However, I will be happy to answer all yuor questions
// if you email me at: LittleBrother@bigfoot.com
//
//
// Many variables have been added as MENBER VARIABLES of the AqEmuDlg class,
// this is to ensure fastest possible execution time of the Z80 CPU engine.
//

#include "stdafx.h"
#include "AqEmu.h"
#include "AqEmuDlg.h"
#include "ProcAdvanced.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define AQ_SCREENTOP 0x3000 //starting address in Z80 ram of Aquarius screen matrix.
#define SFLAG 0x80
#define ZFLAG 0x40
#define HFLAG 0x10
#define PFLAG 0x04
#define NFLAG 0x02
#define CFLAG 0x01

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CAqEmuDlg dialog

CAqEmuDlg::CAqEmuDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CAqEmuDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CAqEmuDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CAqEmuDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAqEmuDlg)
	DDX_Control(pDX, IDC_STATBAR, m_StatBar);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAqEmuDlg, CDialog)
	//{{AFX_MSG_MAP(CAqEmuDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_COMMAND(IDM_ABOUTBOX, OnAboutbox)
	ON_COMMAND(ID_PROCPAUSE, OnProcPause)
	ON_COMMAND(ID_VIEW_100, OnView100)
	ON_COMMAND(ID_VIEW_200, OnView200)
	ON_COMMAND(ID_VIEW_400, OnView400)
	ON_WM_TIMER()
	ON_WM_KEYDOWN()
	ON_WM_SYSKEYDOWN()
	ON_WM_KEYUP()
	ON_WM_SIZE()
	ON_COMMAND(ID_PROCESSOR_RESET, OnProcessorReset)
	ON_COMMAND(ID_LOADROM, OnLoadRom)
	ON_COMMAND(ID_VIEW_CLEARSCREENRAM, OnViewClearScreenRam)
	ON_COMMAND(ID_PROCESSOR_ADVANCED, OnProcessorAdvanced)
	ON_COMMAND(ID_PROCESSOR_START, OnProcessorStart)
	ON_COMMAND(ID_DEBUG_LOGTOFILE, OnDebugLogToFile)
	ON_COMMAND(ID_DEBUG_STOPLOGGING, OnDebugStoplogging)
	ON_WM_CLOSE()
	ON_COMMAND(IDCLOSE, OnFileExit)
	ON_COMMAND(ID_DEBUG_TEST, OnDebugTest)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CAqEmuDlg message handlers

BOOL CAqEmuDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	OnAboutbox();
	// TODO: Add extra initialization here
	nZoomX=2; //Initial zoom level is 1
	nZoomY=2;

	ZapMemory();
	ZapIoSpace();
	FillKeyTable();
	SetParity(); //fill the PARITY array.

	
	bInitDone=FALSE;	lCount=0x0000;	bRomLoaded=FALSE;
	bLooping=FALSE;		bRun=FALSE;		OnView200();
	bShiftDown=FALSE;	bCtrlDown=FALSE;
	OnLoadRom();		bLogging=FALSE;	
	nAddrStart=0x0000;	nAddrStop=0xffff;
	nSpaces=0;
	myZ80.Reset();
	
	nTimerID=SetTimer(1,333,NULL);
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CAqEmuDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CAqEmuDlg::OnPaint() 
{
	
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CPaintDC dc(this); // device context for painting
		myCDC = &dc;		// save our CDC for later.
		DrawScreen();	//Draw the start screen and init some variables.
		//CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CAqEmuDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}


void CAqEmuDlg::OnAboutbox() 
{
	CAboutDlg dlg;
	dlg.DoModal();
}

void CAqEmuDlg::OnProcPause() 
{
	//this is actually a PrcoStop
	//becuase when you restart the processor it starts from pc=0x0000
		bRun=FALSE;

}


void CAqEmuDlg::DoEvents()
{
	MSG msg;

	// Process existing messages in the application's message queue.
	// When the queue is empty, do clean up and return.
	while (::PeekMessage(&msg,NULL,0,0,PM_NOREMOVE) )
	{
		if (!AfxGetThread()->PumpMessage())
			return;
	}
}

void CAqEmuDlg::OnView100() 
{
	nZoomX=1;	
	nZoomY=1;
	SetWindowText("Aquarius Emulator (100%)");
	SetWindowPos( &wndTop, 0, 0, 370, 280, SWP_NOMOVE );
	UpdateWindow();	
}

void CAqEmuDlg::OnView200() 
{
	nZoomX=2;
	nZoomY=2;
	SetWindowText("Aquarius Emulator (200%)");
	SetWindowPos( &wndTop, 0, 0, 690, 480, SWP_NOMOVE );
	UpdateWindow();
}

void CAqEmuDlg::OnView400() 
{
	int nReply;
	nReply=AfxMessageBox("Is 2x Not big enough for you?",MB_YESNO+MB_ICONQUESTION);
	if (nReply==IDYES)
		return;

	AfxMessageBox("Tuff! - Buy a magnifying glass.");

}

void CAqEmuDlg::DrawScreen()
{
		if (!bInitDone) //used to save time later.
		{
			dcb.CreateCompatibleDC(NULL);
			m_Bitmap1.LoadBitmap(IDB_BITMAP4);
			pOldBitmap = dcb.SelectObject( &m_Bitmap1 );
			bInitDone=TRUE;
		}

		for (UINT nRow=0; nRow<25;nRow++)
		{
			for (UINT nCol=0; nCol<=39; nCol++)
			{
				ShowChar(nCol,nRow,Memory[AQ_SCREENTOP + nCol+(nRow*40)]);
			}
		}
}

void CAqEmuDlg::OnTimer(UINT nIDEvent) 
{

	InvalidateScreen();
	UpdateWindow();
	CString strMsg;
	strMsg.Format("PC:%4x, OP:%4x, A:%4x, F:%4x, BC:%4x, DE:%4x, HL %4x,SP:%4x",myZ80.pc,Memory[myZ80.pc],myZ80.a,myZ80.f,myZ80.bc,myZ80.de,myZ80.hl,myZ80.sp);
	m_StatBar.SetWindowText(strMsg);
	//CDialog::OnTimer(nIDEvent);

}

void CAqEmuDlg::OnOK() 
{
	IoSpace[0x7fff]=0x0f;
	IoSpace[0x00ff]=0xf7; //signal that some key is down.
	IoSpace[0xfeff]=0xf7; //Signal that the ENTER key is down.
/*	//Check if processor is still running.
	//If so, advise user to kill processor before exiting.
	if (bLooping)
	{
		AfxMessageBox("Can't exit, processor is still running.\nStop processor then exit.");
		return;
	}
	if (bLogging)
		cfLogFile.Close();

	//OK, Now we can terminate the loop.
	CDialog::OnOK();
	*/
}

void CAqEmuDlg::InvalidateScreen()
{
	RECT r;
	r.top=30;
	r.left=10;
	r.right=320*nZoomX+10;
	r.bottom=192*nZoomY+50;
	InvalidateRect(&r,FALSE);
}

void CAqEmuDlg::ZapMemory()
{
	for(int x=0x3000;x<=(0xf000);x++)
	{
		Memory[x]=(0x00); //Fill memory with NOP.
	}
	for( x=0xf000;x<=(0xffff);x++)
	{
		Memory[x]=(0x76); //Fill memory with HALT
	}

}

void CAqEmuDlg::OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags) 
{
	/*
	Here is the disassmbly from the actual ROM:
l1f00:  inc     (hl)			; increment the scan count
        ld      b,$7f			; read column 8 ($7f = 01111111)
        in      a,(c)			;
        bit     5,a			; CTRL key down?
        ld      ix,$1f93		; point to start of CTRL key lookup table
        jr      z,$1f19                 ; JUMP to KLOOKUP
        bit     4,a			; SHIFT key down?
        ld      ix,$1f65		; point to start of SHIFT key lookup table
        jr      z,$1f19                 ; JUMP to KLOOKUP
        ld      ix,$1f37		; else point to start of natural key lookup table.

	*/
	if (nChar==0x10)
		bShiftDown=TRUE;

	if (nChar==0x11)
		bCtrlDown=TRUE;

	nPort=(KeyBoard[nChar] & 0xff00) | 0x00ff;
	nVal =(KeyBoard[nChar] & 0x00ff);
	IoSpace[nPort]=nVal;
	IoSpace[0x00ff]=nVal; //signal that a key is down.

	if (bShiftDown)
	{
		IoSpace[0x7fff]&=0xffef; //signal SHIFT KEY IS DOWN
	}
	else
	{
		IoSpace[0x7fff]|=0x0010; // signal shift jey not down
	}

	if (bCtrlDown)
	{
		IoSpace[0x7fff]&=0xffdf; //signal SHIFT KEY IS DOWN
	}
	else
	{
		IoSpace[0x7fff]|=0x0020; // signal shift jey not down
	}

	CString msg;
	msg.Format("%x",nChar);
	SetWindowText(msg);

}
void CAqEmuDlg::OnSysKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags) 
{
	CDialog::OnKeyDown(nChar, nRepCnt, nFlags);
}

void CAqEmuDlg::OnKeyUp(UINT nChar, UINT nRepCnt, UINT nFlags) 
{
	//m_StatBar.SetWindowText("  UP !");

/*	static UINT nCount=0;
	if (nChar > 255) 
		return;

	if (nCount>=960)	//ensure we don't over run the matrix size.
		nCount=0;

	Memory[AQ_SCREENTOP+nCount++]=nChar;	
*/
	IoSpace[0x00ff]=0xff; //signal that NO key is down.
	IoSpace[0xfeff]=0xff; 
	nPort=(KeyBoard[nChar] & 0xff00) | 0x00ff;
	IoSpace[nPort]=0xff;

	if (nChar==0x10)
		bShiftDown=FALSE;

	if (nChar==0x11)
		bCtrlDown=FALSE;




}

void CAqEmuDlg::ShowChar(UINT x, UINT y, UINT nChar)
{
	if (nChar <= 255)
	{
		int cX = (nChar & 0x0F)*8;
		int cY = ((nChar & 0xF0)*8)>>4;

		myCDC->StretchBlt(
						(x*nZoomX*8)+10,
						(y*nZoomY*8)+30,
						8*nZoomX,
						8*nZoomY,
						&dcb,
						cX,cY,
						8,8,
						SRCCOPY);
	}
}

int CAqEmuDlg::ExecuteInstruction()
{
	
	switch (Memory[myZ80.pc])
	{
	case 0x00: {myZ80.pc++; } break;	//NOP
	case 0x01:							//LD BC,nnnn
		{

			myZ80.bc=Memory[++myZ80.pc];
			myZ80.bc+=(Memory[++myZ80.pc]<<8);
			myZ80.pc++;
		} 
		break;

	case 0x02: //LD BC,A
		{
			Memory[myZ80.bc]=myZ80.a;
			myZ80.pc++;
		} 
		break;
	case 0x03: {myZ80.bc=myZ80.IncPair(myZ80.bc);  myZ80.pc++; } break; //INC BC
	case 0x04: {myZ80.bc=myZ80.IncPairH(myZ80.bc); myZ80.pc++; } break; //INC B
	case 0x05: 
		{
			myZ80.bc=myZ80.DecPairH(myZ80.bc); 
			myZ80.pc++; 
		} break; //DEC B
	case 0x06: 
		{
			myZ80.bc&=0x00ff; 
			myZ80.bc+=(Memory[++myZ80.pc]<<8);
			myZ80.pc++;
		} break; //ld b,nn
	case 0x07: 
		{ //RLCA
		UINT  c=0;
		c=((myZ80.a & 0x80)>>7); //Carried bit is bit 7 of Accumulator
		myZ80.a=((myZ80.a<<1) & 0xfe) + c ; // Rotate left and add carried bit
		myZ80.f&=0xc4; //reset H and N flags.
		myZ80.f+=c; // add carried bit.
		myZ80.pc++; 
		} 
		break;
	case 0x08: //EXX af,AF'
		{
			BYTE A=myZ80.a;
			BYTE F=myZ80.f;
			myZ80.a=myZ80.a_;
			myZ80.f=myZ80.f_;
			myZ80.a_=A;
			myZ80.f_=F;
			myZ80.pc++; 
		} 
		break; 
	case 0x09: {myZ80.hl=myZ80.AddPair(myZ80.hl,myZ80.bc); myZ80.pc++;} break;//ADD HL,BC
	case 0x0a: {myZ80.a=Memory[myZ80.bc]        ; myZ80.pc++; } break; //LD A,(BC)
	case 0x0b: {myZ80.bc=myZ80.DecPair(myZ80.bc); myZ80.pc++; } break; //DEC BC
	case 0x0c: {myZ80.bc=myZ80.IncPairL(myZ80.bc);myZ80.pc++; } break; //INC C
	case 0x0d: {myZ80.bc=myZ80.DecPairL(myZ80.bc);myZ80.pc++; } break; //DEC C
	case 0x0e: {myZ80.bc&=0xff00; myZ80.bc+=Memory[++myZ80.pc]; myZ80.pc++; } break; //LD C,nn
	case 0x0f: 
		{
			UINT  c=(myZ80.a & 0x01); //Carried bit is bit 1 of Accumulator
			myZ80.a=((myZ80.a>>1) & 0x7f) + (c<<7); // Rotate left and add carried bit
			myZ80.f&=0xc4; //reset H and N flags.
			myZ80.f|=c; // add carried bit.
			myZ80.pc++; 
		} break; //RRCA

	case 0x10: 
		{
			
			myZ80.bc=myZ80.DecPairH(myZ80.bc); //decrement B
			if ((myZ80.bc & 0xff00)==0) //if b=0 we carry on.
			{
				myZ80.pc+=2; //pre adjust PC
			} else //else we add +/- displacement to PC
			{
				dd=Memory[myZ80.pc+1]; //displacement
				myZ80.pc+=2;  //pre adjust PC to start of next instruction.
				myZ80.pc+=dd; //then add +/- displacment.
			}
		} 
		break; //DJNZ
	case 0x11: 
		{
			myZ80.pc++;
			myZ80.de=Memory[myZ80.pc];
			myZ80.pc++;
			myZ80.de+=(Memory[myZ80.pc]<<8);
			myZ80.pc++;
		} break; //LD DE,nnnn
	case 0x12: 		
		{
			Memory[myZ80.de]=myZ80.a;
			myZ80.pc++;
		} 
		break; //LD (DE),A

	case 0x13: {myZ80.de=myZ80.IncPair(myZ80.de);  myZ80.pc++; } break; //INC DE
	case 0x14: {myZ80.de=myZ80.IncPairH(myZ80.de); myZ80.pc++; } break; //INC D
	case 0x15: {myZ80.de=myZ80.DecPairH(myZ80.de); myZ80.pc++; } break; //DEC D
	case 0x16: {myZ80.de&=0x00ff; myZ80.de+=(Memory[++myZ80.pc]<<8); myZ80.pc++; } break;
	case 0x17: 
		{
			BYTE c =(myZ80.a & 0x80)>>7; //carry will be bit7 of a
			BYTE cf=(myZ80.f & 0x01); //bit 0 will be current CF
			myZ80.a=(myZ80.a << 1 ) + cf;
			myZ80.f=(myZ80.f & 0xfe) + c; //clear CF and add original bit 7 of A
			myZ80.pc++; 
		} break; //RLA
	case 0x18: 
		{
			dd=Memory[myZ80.pc+1];
			myZ80.pc+=2;  //pre load PC
			myZ80.pc+=dd; //adjust PC by dd (+/-)
				if (bLogging)
				{
					strMsg.Format("JR     %4x\r\n",myZ80.pc);
					cfLogFile.Write(strMsg.GetBuffer(132),strMsg.GetLength());
				}

		} break;
	case 0x19: 
		{
			myZ80.hl=myZ80.AddPair(myZ80.hl,myZ80.de); 
			myZ80.pc++;
		} break; //add hl.de
	case 0x1a: {myZ80.a=Memory[myZ80.de]; myZ80.pc++;} break;
	case 0x1b: {myZ80.de=myZ80.DecPair(myZ80.de); myZ80.pc++; } break;
	case 0x1c: {myZ80.de=myZ80.IncPairL(myZ80.de);myZ80.pc++; } break; //inc e
	case 0x1d: {myZ80.de=myZ80.DecPairL(myZ80.de);myZ80.pc++; } break; //dec e
	case 0x1e: {myZ80.de&=0xff00; myZ80.de+=Memory[++myZ80.pc];myZ80.pc++; } break; //ld e,n
	case 0x1f: 
		{
			BYTE c =(myZ80.a & 0x01); //carry will be bit0 of a
			BYTE cf=(myZ80.f & 0x01); //bit 0 will be current CF
			myZ80.a=(myZ80.a >> 1  ) + (cf<<7);
			myZ80.f=(myZ80.f & 0xfe) + c; //clear CF and add original bit 7 of A
			myZ80.pc++; 
		} 
		break; //RRA

	case 0x20: 
		{
			myZ80.pc++;
			dd=Memory[myZ80.pc];  //retrieve the displacement byte.
			myZ80.pc++; //pre adjust PC
			
			if ((myZ80.f & 0x40)==0x00) //if Zflag not set
			{
				myZ80.pc+=dd;
				if (bLogging)
				{
					strMsg.Format("JR  NZ  %4x\r\n",myZ80.pc);
					cfLogFile.Write(strMsg.GetBuffer(132),strMsg.GetLength());
				}

			}


		} break; //jr nz,dd
	case 0x21: 
		{
			myZ80.hl=Memory[++myZ80.pc];
			myZ80.hl+=(Memory[++myZ80.pc]<<8);
			myZ80.pc++;
		} break; //LD HL,NNNN

	case 0x22: 
		{
			nAddr = Memory[++myZ80.pc];
			nAddr += Memory[++myZ80.pc]<<8;
			
			Memory[nAddr]=(BYTE) ( myZ80.hl & 0x00ff);
			nAddr++;
			Memory[nAddr]=(BYTE) (((myZ80.hl & 0xff00)>>8) & 0x00ff);
			myZ80.pc++;
			
		} break; //LD (nnnn),HL
	case 0x23: 
		{
			myZ80.hl=myZ80.IncPair(myZ80.hl); 
			myZ80.pc++; 
		} break; //inc hl
	case 0x24: {myZ80.hl=myZ80.IncPairH(myZ80.hl);myZ80.pc++; } break; //inc h
	case 0x25: {myZ80.hl=myZ80.DecPairH(myZ80.hl);myZ80.pc++; } break; //dec h
	case 0x26: {myZ80.hl=(myZ80.hl & 0x00ff)+(Memory[++myZ80.pc]<<8); myZ80.pc++; } break; //LD H,nn
	//case 0x27: {myZ80.pc++; } break; //DAA  The Aquarius ROM doesn't use this instruction. SO i've ignored it!
	case 0x28: 
		{
			myZ80.pc++;
			dd=Memory[myZ80.pc];  //retrieve the displacement byte.
			myZ80.pc++; //pre adjust PC
			
			if ((myZ80.f & 0x40)==0x40) //if Zflag is set
			{
				myZ80.pc+=dd;
				if (bLogging)
				{
					strMsg.Format("JR  Z  %4x\r\n",myZ80.pc);
					cfLogFile.Write(strMsg.GetBuffer(132),strMsg.GetLength());
				}

			}
		} break; //JR Z,dd
	case 0x29: {myZ80.hl=myZ80.AddPair(myZ80.hl,myZ80.hl); myZ80.pc++; } break; //ADD HL,HL
	case 0x2a: 
		{
			myZ80.pc++;
			nAddr = Memory[myZ80.pc];
			myZ80.pc++;
			nAddr+=(Memory[myZ80.pc]<<8);
			myZ80.hl=Memory[nAddr];
			myZ80.hl+=(Memory[nAddr+1]<<8);
			myZ80.pc++; 
		} break; //LD HL,(nnnn) 
	case 0x2b: 
		{
			myZ80.hl=myZ80.DecPair(myZ80.hl);  
			myZ80.pc++; 
		} break; //dec HL
	case 0x2c: {myZ80.hl=myZ80.IncPairL(myZ80.hl); myZ80.pc++; } break; //inc L
	case 0x2d: {myZ80.hl=myZ80.DecPairL(myZ80.hl); myZ80.pc++; } break; //dec L
	case 0x2e: 
		{
			myZ80.hl&=0xff00; //clear L
			myZ80.hl+=Memory[++myZ80.pc];
			myZ80.pc++; 
		} break; //LD L,NN

	case 0x2f: //CPL
		{
			myZ80.a = ~myZ80.a;
			myZ80.f|=0x12; //set H and N flags - leave others untouched.
			myZ80.pc++; 
		} break;

	case 0x30: 
		{
			myZ80.pc++;
			dd=Memory[myZ80.pc];  //retrieve the displacement byte.
			myZ80.pc++; //pre adjust PC
			
			if ((myZ80.f & 0x01)==0x00) //if CF not set
			{
				myZ80.pc+=dd;
				if (bLogging)
				{
					strMsg.Format("JR  NC  %4x\r\n",myZ80.pc);
					cfLogFile.Write(strMsg.GetBuffer(132),strMsg.GetLength());
				}

			}
		} break; //JR NC,dd
	case 0x31: //LD SP,NNNN
		{
			myZ80.sp=Memory[++myZ80.pc];
			myZ80.sp+=(Memory[++myZ80.pc]<<8);
			myZ80.pc++; 
		} break;
	case 0x32: 
		{
			nAddr = Memory[++myZ80.pc];
			nAddr+=(Memory[++myZ80.pc]<<8);
			Memory[nAddr]=myZ80.a;
			myZ80.pc++; 
		} break; //LD (nnnn),a
	case 0x33: {myZ80.IncPair(myZ80.sp); myZ80.pc++; } break; //inc SP
	case 0x34: 
		{
			Memory[myZ80.hl]=Memory[myZ80.hl]+1;	//increment memory pointed to by HL
			myZ80.f&=0x01; //clear all flags except CF
			if (Memory[myZ80.hl]==0x00)
				myZ80.f=0x40;
			
			myZ80.f|=(Memory[myZ80.hl] & 0x80); //set SF as reqd.
			
			myZ80.pc++; 
		} break;
	case 0x35: 
		{
			Memory[myZ80.hl]=Memory[myZ80.hl]-1;	//decrement memory pointed to by HL
			myZ80.f&=0x01; //clear all flags except CF
			myZ80.f|=0x02; //set N flag
			if (Memory[myZ80.hl]==0x00)
				myZ80.f=0x40;
			if (Memory[myZ80.hl]>0x7f)
				myZ80.f|=0x80;
			myZ80.pc++;
		} break;
	case 0x36: 
		{
			Memory[myZ80.hl]=Memory[++myZ80.pc];
			myZ80.pc++; 
		} break; //ld (hl),nn
	case 0x37: {myZ80.f|=0x01;myZ80.pc++; } break; //SCF
	case 0x38: 
		{
			myZ80.pc++;
			dd=Memory[myZ80.pc];  //retrieve the displacement byte.
			myZ80.pc++; //pre adjust PC
			
			if ((myZ80.f & 0x01)==0x01) //if CF is set
			{
				myZ80.pc+=dd;
				if (bLogging)
				{
					strMsg.Format("JR  C  %4x\r\n",myZ80.pc);
					cfLogFile.Write(strMsg.GetBuffer(132),strMsg.GetLength());
				}

			}
		} break;
	case 0x39: 
		{
			myZ80.hl=myZ80.AddPair(myZ80.hl,myZ80.sp);  
			myZ80.pc++; 
		} break;
	case 0x3a: 
		{
			nAddr=Memory[++myZ80.pc];
			nAddr+=(Memory[++myZ80.pc]<<8);
			myZ80.a=Memory[nAddr];
			myZ80.pc++; 
		} break; //LD A,(nnnn);
	case 0x3b: {myZ80.sp=myZ80.DecPair(myZ80.sp); myZ80.pc++; } break;
	case 0x3c: 
		{
			myZ80.a++;
			myZ80.a&=0xff;
			myZ80.f&=0x01;
			if (myZ80.a==0x00) //chgeck/set Z flag
				myZ80.f |= 0x40;

			if (myZ80.a>=0x7f) //check set S flag
				myZ80.f |= 0x80;
			
			if (myZ80.a==0x7f) //check set H flag
				myZ80.f |= 0x10;
			myZ80.pc++; 
		} break; //inc a
	case 0x3d: 
		{
			myZ80.f &= 0x01; //Clear all flags except CF
			myZ80.f |= 0x02; //set N flag as this is a DEC instruction.
			myZ80.a--;		 //dec A
			myZ80.a&=0xff;   // keep to 8 bits.

			if (myZ80.a==0x00) //chgeck/set Z flag
				myZ80.f |= 0x40;

			if (myZ80.a>=0x7f) //check set S flag
				myZ80.f |= 0x80;
			
			if (myZ80.a==0xff) //check set V flag
				myZ80.f |= 0x04;

			if (myZ80.a==0x7f) //check set H flag
				myZ80.f |= 0x10;

			myZ80.pc++; 
		} break; //DEC A
	case 0x3e: 
		{
			myZ80.pc++;
			myZ80.a=Memory[myZ80.pc];
			myZ80.pc++; 
		} break; //ld a,nn
	case 0x3f: //CCF Compliment the carry flag.
		{
			if ((myZ80.f & 0x01)==0x01) //is carry flag set?
			{
				myZ80.f &= 0xfe; //if yES we reset it.
			}else
			{
				myZ80.f |=0x01; //otherwise we SET it.
			}
			myZ80.pc++;  //then move on.
		} break;

	case 0x40: {myZ80.pc++; } break; //ld b,b - we do NADA!
	case 0x41: //LD B,C
		{
			myZ80.bc &=0x00ff;
			myZ80.bc +=(myZ80.bc & 0x00ff) << 8;
			myZ80.pc++; 
		} break;
	case 0x42:  //ld b,d
		{
			myZ80.bc &=0x00ff; //clear out B
			myZ80.bc +=(myZ80.de & 0xff00); //B=D
			myZ80.pc++; 
		} break;
	case 0x43: //ld,b,e
		{
			myZ80.bc &=0x00ff;
			myZ80.bc +=(myZ80.de & 0x00ff) << 8;
			myZ80.pc++; 
		} break;
	case 0x44: //ld b,h
		{
			myZ80.bc &=0x00ff;
			myZ80.bc +=(myZ80.hl & 0xff00);
			myZ80.pc++; 
		} break;
	case 0x45: //ld b,l
		{
			myZ80.bc &=0x00ff;
			myZ80.bc +=(myZ80.hl & 0x00ff) << 8;
			myZ80.pc++; 
		} break;
	case 0x46: //ld b,(hl)
		{
			myZ80.bc &= 0x00ff;
			myZ80.bc += (Memory[myZ80.hl]<<8);
			myZ80.pc++; 
		} break;
	case 0x47: //LD B,A
		{
			myZ80.bc &=0x00ff;
			myZ80.bc +=(myZ80.a ) << 8;
			myZ80.pc++; 
		} break;

	case 0x48: //ld c,b
		{
			myZ80.bc &= 0xff00;
			myZ80.bc += (myZ80.bc & 0xff00)>>8;
			myZ80.pc++; 
		} break;
	//case 0x49: {myZ80.pc++;} break; //ld c,c - yeah like we need to do that!
	case 0x4a: //ld c,d
		{
			myZ80.bc &= 0xff00;
			myZ80.bc += (myZ80.de & 0xff00)>>8;
			myZ80.pc++; 
		} break;
	case 0x4b: //ld c,e
		{
			myZ80.bc &= 0xff00;
			myZ80.bc += (myZ80.de & 0x00ff);
			myZ80.pc++; 
		} break;
	case 0x4c: //ld c,h
		{
			myZ80.bc &= 0xff00;
			myZ80.bc += (myZ80.hl & 0xff00)>>8;
			myZ80.pc++; 
		} break;

	case 0x4d: //ld c,l
		{
			myZ80.bc &= 0xff00;
			myZ80.bc += (myZ80.hl & 0x00ff);
			myZ80.pc++; 
		} break;
	case 0x4e: //ld c,(hl)
		{
			myZ80.bc &= 0xff00;
			myZ80.bc += Memory[myZ80.hl];
			myZ80.pc++; 
		} break;
	case 0x4f: //ld c,a
		{
			myZ80.bc &= 0xff00;
			myZ80.bc += myZ80.a;
			myZ80.pc++; 
		} break;

	case 0x50: //ld d,b
		{
			myZ80.de&=0x00ff; //clear d
			myZ80.de+=(myZ80.bc &0xff00);
			myZ80.pc++; 
		} break;
	case 0x51: //LD d,C
		{
			myZ80.de &=0x00ff;
			myZ80.de +=(myZ80.bc & 0x00ff) << 8;
			myZ80.pc++; 
		} break;
	case 0x52: //ld d,d = nada!!!
		{
			myZ80.pc++; 
		} break;
	case 0x53: //ld,d,e
		{
			myZ80.de &=0x00ff;
			myZ80.de +=(myZ80.de & 0x00ff) << 8;
			myZ80.pc++; 
		} break;
	case 0x54: //ld d,h
		{
			myZ80.de &=0x00ff;
			myZ80.de +=(myZ80.hl & 0xff00);
			myZ80.pc++; 
		} break;
	case 0x55: //ld d,l
		{
			myZ80.de &=0x00ff;
			myZ80.de +=(myZ80.hl & 0x00ff) << 8;
			myZ80.pc++; 
		} break;
	case 0x56: //ld d,(hl)
		{
			myZ80.de &= 0x00ff;
			myZ80.de += (Memory[myZ80.hl] << 8);
			myZ80.pc++; 
		} break;
	case 0x57: //LD d,A
		{
			myZ80.de &=0x00ff;
			myZ80.de +=(myZ80.a ) << 8;
			myZ80.pc++; 
		} break;
	case 0x58: //ld e,b
		{
			myZ80.de &= 0xff00;
			myZ80.de += (myZ80.bc & 0xff00)>>8;
			myZ80.pc++; 
		} break;
	case 0x59: //ld e,c
		{
			myZ80.de &= 0xff00;
			myZ80.de += (myZ80.bc & 0x00ff);
			myZ80.pc++; 
		} break; 
	case 0x5a: //ld e,d
		{
			myZ80.de &= 0xff00;
			myZ80.de += (myZ80.de & 0xff00)>>8;
			myZ80.pc++; 
		} break;
	case 0x5b: //ld e,e
		{
			myZ80.pc++; 
		} break;
	case 0x5c: //ld e,h
		{
			myZ80.de &= 0xff00;
			myZ80.de += (myZ80.hl & 0xff00)>>8;
			myZ80.pc++; 
		} break;

	case 0x5d: //ld e,l
		{
			myZ80.de &= 0xff00;
			myZ80.de += (myZ80.hl & 0x00ff);
			myZ80.pc++; 
		} break;
	case 0x5e: //ld e,(hl)
		{
			myZ80.de &= 0xff00;
			myZ80.de += Memory[myZ80.hl];
			myZ80.pc++; 
		} break;
	case 0x5f: //ld e,a
		{
			myZ80.de &= 0xff00;
			myZ80.de += myZ80.a;
			myZ80.pc++; 
		} break;
	case 0x60: //ld h,b
		{
			myZ80.hl&=0x00ff; //clear d
			myZ80.hl+=(myZ80.bc &0xff00);
			myZ80.pc++; 
		} break;
	case 0x61: //LD h,C
		{
			myZ80.hl &=0x00ff;
			myZ80.hl +=(myZ80.bc & 0x00ff) << 8;
			myZ80.pc++; 
		} break;
	case 0x62: //ld h,d 
		{
			myZ80.hl &=0x00ff; 
			myZ80.hl +=(myZ80.de & 0xff00); 
			myZ80.pc++; 
		} break;
	case 0x63: //ld h,e
		{
			myZ80.hl &=0x00ff;
			myZ80.hl +=(myZ80.de & 0x00ff) << 8;
			myZ80.pc++; 
		} break;
	case 0x64: //ld h,h
		{
			myZ80.pc++; 
		} break;
	case 0x65: //ld h,l
		{
			myZ80.hl &=0x00ff;
			myZ80.hl +=(myZ80.hl & 0x00ff) << 8;
			myZ80.pc++; 
		} break;
	case 0x66: //ld h,(hl)
		{
			nAddr=myZ80.hl;
			myZ80.hl &= 0x00ff;
			myZ80.hl += (Memory[nAddr] << 8);
			myZ80.pc++; 
		} break;
	case 0x67: //LD h,A
		{
			myZ80.hl &=0x00ff;
			myZ80.hl +=(myZ80.a ) << 8;
			myZ80.pc++; 
		} break;

	case 0x68: //ld l,b
		{
			myZ80.hl &= 0xff00;
			myZ80.hl += (myZ80.bc & 0xff00)>>8;
			myZ80.pc++; 
		} break;
	case 0x69: //ld l,c
		{
			myZ80.hl &= 0xff00;
			myZ80.hl += (myZ80.bc & 0x00ff);
			myZ80.pc++; 
		} break; 
	case 0x6a: //ld l,d
		{
			myZ80.hl &= 0xff00;
			myZ80.hl += (myZ80.de & 0xff00)>>8;
			myZ80.pc++; 
		} break;
	case 0x6b: //ld l,e
		{
			myZ80.hl &= 0xff00;
			myZ80.hl += (myZ80.de & 0x00ff);
			myZ80.pc++; 
		} break;
	case 0x6c: //ld l,h
		{
			myZ80.hl &= 0xff00;
			myZ80.hl += (myZ80.hl & 0xff00)>>8;
			myZ80.pc++; 
		} break;

	case 0x6d: //ld l,l
		{
			myZ80.pc++; 
		} break;
	case 0x6e: //ld l,(hl)
		{
			nAddr=myZ80.hl;
			myZ80.hl &= 0xff00;
			myZ80.hl += Memory[nAddr];
			myZ80.pc++; 
		} break;
	case 0x6f: //ld l,a
		{
			myZ80.hl &= 0xff00;
			myZ80.hl += myZ80.a;
			myZ80.pc++; 
		} break;

	case 0x70: 
		{
			Memory[myZ80.hl]=(myZ80.bc & 0xff00) >> 8;
			myZ80.pc++; 
		} break;
	case 0x71: 
		{
			Memory[myZ80.hl]=(myZ80.bc & 0x00ff);
			myZ80.pc++; 
		} break;
	case 0x72: 
		{
			Memory[myZ80.hl]=(myZ80.de & 0xff00) >> 8;
			myZ80.pc++; 
		} break;
	case 0x73: 
		{
			Memory[myZ80.hl]=(myZ80.de & 0x00ff);
			myZ80.pc++; 
		} break;
	case 0x74: 
		{
			Memory[myZ80.hl]=(myZ80.hl & 0xff00) >> 8;
			myZ80.pc++; 
		} break;
	case 0x75: 
		{
			Memory[myZ80.hl]=(myZ80.hl & 0x00ff);
			myZ80.pc++; 
		} break;

	case 0x76: { /* HALT*/ }  break;
	case 0x77: {Memory[myZ80.hl]=myZ80.a;myZ80.pc++; } break; //ld (hl),a
	case 0x78: {myZ80.a=(myZ80.bc & 0xff00)>>8 ;myZ80.pc++; } break; //ld a,b
	case 0x79: {myZ80.a=(myZ80.bc & 0x00ff)    ;myZ80.pc++; } break; //ld a,c
	case 0x7a: {myZ80.a=(myZ80.de & 0xff00)>>8 ;myZ80.pc++; } break; //ld a.d
	case 0x7b: {myZ80.a=(myZ80.de & 0x00ff)    ;myZ80.pc++; } break; //ld a,e
	case 0x7c: {myZ80.a=(myZ80.hl & 0xff00)>>8 ;myZ80.pc++; } break; //ld a,h
	case 0x7d: {myZ80.a=(myZ80.hl & 0x00ff)    ;myZ80.pc++; } break; //ld a,l
	case 0x7e: 
		{
			myZ80.a=Memory[myZ80.hl]       ;
			myZ80.pc++; 
		} break; //ld a,(hl)
	case 0x7f: {myZ80.pc++; } break; //ld a,a
	case 0x80: 
		{
			nResult=myZ80.a + ((myZ80.bc & 0xff00)>>8);
			myZ80.a=nResult & 0x00ff; //restrict to 8 bits
			myZ80.f=0; //clear all flags

			if (myZ80.a==0x00) //chgeck/set Z flag
				myZ80.f |= 0x40;

			if (myZ80.a>0x7f) //check set S flag
				myZ80.f |= 0x80;

			if (nResult > 0x00ff)
				myZ80.f |= 0x01; //check and set CF

			myZ80.pc++; 
		} break;
	case 0x81: 
		{
			nResult=myZ80.a + (myZ80.bc & 0x00ff);
			myZ80.a=nResult & 0x00ff; //restrict to 8 bits
			myZ80.f=0; //clear all flags

			if (myZ80.a==0x00) //chgeck/set Z flag
				myZ80.f |= 0x40;

			if (myZ80.a>0x7f) //check set S flag
				myZ80.f |= 0x80;

			if (nResult > 0x00ff)
				myZ80.f |= 0x01; //check and set CF

			myZ80.pc++; 
		} break;

	case 0x82: 
		{
			nResult=myZ80.a + ((myZ80.de & 0xff00)>>8);
			myZ80.a=nResult & 0x00ff; //restrict to 8 bits
			myZ80.f=0; //clear all flags

			if (myZ80.a==0x00) //chgeck/set Z flag
				myZ80.f |= 0x40;

			if (myZ80.a>0x7f) //check set S flag
				myZ80.f |= 0x80;

			if (nResult > 0x00ff)
				myZ80.f |= 0x01; //check and set CF

			myZ80.pc++; 
		} break;
	case 0x83: 
		{
			nResult=myZ80.a + (myZ80.de & 0x00ff);
			myZ80.a=nResult & 0x00ff; //restrict to 8 bits
			myZ80.f=0; //clear all flags

			if (myZ80.a==0x00) //chgeck/set Z flag
				myZ80.f |= 0x40;

			if (myZ80.a>0x7f) //check set S flag
				myZ80.f |= 0x80;

			if (nResult > 0x00ff)
				myZ80.f |= 0x01; //check and set CF

			myZ80.pc++; 
		} break;

	case 0x84: 
		{
			nResult=myZ80.a + ((myZ80.hl & 0xff00)>>8);
			myZ80.a=nResult & 0x00ff; //restrict to 8 bits
			myZ80.f=0; //clear all flags

			if (myZ80.a==0x00) //chgeck/set Z flag
				myZ80.f |= 0x40;

			if (myZ80.a>0x7f) //check set S flag
				myZ80.f |= 0x80;

			if (nResult > 0x00ff)
				myZ80.f |= 0x01; //check and set CF

			myZ80.pc++; 
		} break;
	case 0x85: 
		{
			nResult=myZ80.a + (myZ80.hl & 0x00ff);
			myZ80.a=nResult & 0x00ff; //restrict to 8 bits
			myZ80.f=0; //clear all flags

			if (myZ80.a==0x00) //chgeck/set Z flag
				myZ80.f |= 0x40;

			if (myZ80.a>0x7f) //check set S flag
				myZ80.f |= 0x80;

			if (nResult > 0x00ff)
				myZ80.f |= 0x01; //check and set CF

			myZ80.pc++; 
		} break;

	case 0x86: 
		{
			nResult=myZ80.a+Memory[myZ80.hl];
			myZ80.a=nResult & 0x00ff; //restrict to 8 bits
			myZ80.f=0; //clear all flags

			if (myZ80.a==0x00) //chgeck/set Z flag
				myZ80.f |= 0x40;

			if (myZ80.a>0x7f) //check set S flag
				myZ80.f |= 0x80;

			if (nResult > 0x00ff)
				myZ80.f |= 0x01; //check and set CF

			myZ80.pc++; 
		} break;

	case 0x87: 
		{
			nResult=myZ80.a + myZ80.a;
			myZ80.a=nResult & 0x00ff;
			myZ80.f=0; //clear all flags
			if (myZ80.a==0x00) //check/set Z flag
				myZ80.f |= 0x40;

			if (myZ80.a>0x7f) //check set S flag
				myZ80.f |= 0x80;
			if (nResult >0xff)
				myZ80.f |= 0x01; //check set CF
			myZ80.pc++; 
		} break;
	case 0x88: 
		{
			nResult=myZ80.a+((myZ80.bc & 0xff00)>>8);
			nResult+=(myZ80.f & 0x01); //add CF too.
			myZ80.a=nResult&0x00ff;

			myZ80.f=0; //clear all flags
			if (myZ80.a==0x00) //chgeck/set Z flag
				myZ80.f |= 0x40;

			if (myZ80.a>0x7f) //check set S flag
				myZ80.f |= 0x80;
			
			if (nResult >0xff)
				myZ80.f|=0x01;

			myZ80.pc++; 
		} break;
	case 0x89: 
		{
			nResult=myZ80.a+(myZ80.bc & 0x00ff);
			nResult+=(myZ80.f & 0x01); //add CF too.
			myZ80.a=nResult&0x00ff;

			myZ80.f=0; //clear all flags
			if (myZ80.a==0x00) //chgeck/set Z flag
				myZ80.f |= 0x40;

			if (myZ80.a>0x7f) //check set S flag
				myZ80.f |= 0x80;
			
			if (nResult >0xff)
				myZ80.f|=0x01;
			
			
			myZ80.pc++; 
		} break;

	case 0x8a: 
		{
			nResult=myZ80.a+((myZ80.de & 0xff00)>>8);
			nResult+=(myZ80.f & 0x01); //add CF too.
			myZ80.a=nResult&0x00ff;

			myZ80.f=0; //clear all flags
			if (myZ80.a==0x00) //chgeck/set Z flag
				myZ80.f |= 0x40;

			if (myZ80.a>0x7f) //check set S flag
				myZ80.f |= 0x80;
			
			if (nResult >0xff)
				myZ80.f|=0x01;

			myZ80.pc++; 
		} break;
	case 0x8b: 
		{
			nResult=myZ80.a+(myZ80.de & 0x00ff);
			nResult+=(myZ80.f & 0x01); //add CF too.
			myZ80.a=nResult&0x00ff;

			myZ80.f=0; //clear all flags
			if (myZ80.a==0x00) //chgeck/set Z flag
				myZ80.f |= 0x40;

			if (myZ80.a>0x7f) //check set S flag
				myZ80.f |= 0x80;
			
			if (nResult >0xff)
				myZ80.f|=0x01;
			
			
			myZ80.pc++; 
		} break;

	case 0x8c: 
		{
			nResult=myZ80.a+((myZ80.hl & 0xff00)>>8);
			nResult+=(myZ80.f & 0x01); //add CF too.
			myZ80.a=nResult&0x00ff;

			myZ80.f=0; //clear all flags
			if (myZ80.a==0x00) //chgeck/set Z flag
				myZ80.f |= 0x40;

			if (myZ80.a>0x7f) //check set S flag
				myZ80.f |= 0x80;
			
			if (nResult >0xff)
				myZ80.f|=0x01;

			myZ80.pc++; 
		} break;
	case 0x8d: 
		{
			nResult=myZ80.a+(myZ80.hl & 0x00ff);
			nResult+=(myZ80.f & 0x01); //add CF too.
			myZ80.a=nResult&0x00ff;

			myZ80.f=0; //clear all flags
			if (myZ80.a==0x00) //chgeck/set Z flag
				myZ80.f |= 0x40;

			if (myZ80.a>0x7f) //check set S flag
				myZ80.f |= 0x80;
			
			if (nResult >0xff)
				myZ80.f|=0x01;
			
			
			myZ80.pc++; 
		} break;



	case 0x8e: 		//adc a,(hl)
		{
			nResult=myZ80.a+Memory[myZ80.hl];
			nResult+=(myZ80.f & 0x01); //add CF too.
			myZ80.a=nResult&0x00ff;

			myZ80.f=0; //clear all flags
			if (myZ80.a==0x00) //chgeck/set Z flag
				myZ80.f |= 0x40;

			if (myZ80.a>0x7f) //check set S flag
				myZ80.f |= 0x80;
			
			if (nResult >0xff)
				myZ80.f|=0x01;
		} break;


	case 0x8f: //adc a,a
		{
			myZ80.a+=myZ80.a;
			myZ80.a+=(myZ80.f & 0x01); //add CF too.
			myZ80.f=0; //clear all flags
			if (myZ80.a==0x00) //chgeck/set Z flag
				myZ80.f |= 0x40;

			if (myZ80.a>0x7f) //check set S flag
				myZ80.f |= 0x80;
			myZ80.pc++; 
		} break;


	case 0x90: 
		{
			nResult;
			nResult=myZ80.a - ((myZ80.bc & 0xff00)>>8);
			myZ80.f=0x02; //clear all flags, set N flag.
			myZ80.a=(nResult & 0xff);
			
			if (nResult <0x00)
				myZ80.f|=0x01; //set C flags

			if (myZ80.a==0x00)
				myZ80.f|=0x40;

			if (myZ80.a>0x7f)
				myZ80.f|=0x80;

			myZ80.pc++; 
		} break; //SUB A,B
	case 0x91: 
		{
			nResult;
			nResult=myZ80.a - (myZ80.bc & 0x00ff);
			myZ80.f=0x02; //clear all flags, set N flag.
			myZ80.a=(nResult & 0xff);
			
			if (nResult <0x00)
				myZ80.f|=0x01; //set S and C flags

			if (myZ80.a==0x00)
				myZ80.f|=0x40;

			if (myZ80.a>0x7f)
				myZ80.f|=0x80;

			myZ80.pc++; 
		} break; //SUB A,c
	case 0x92: 
		{
			nResult;
			nResult=myZ80.a - ((myZ80.de & 0xff00)>>8);
			myZ80.f=0x02; //clear all flags, set N flag.
			myZ80.a=(nResult & 0xff);
			
			if (nResult <0x00)
				myZ80.f|=0x01; //set S and C flags

			if (myZ80.a==0x00)
				myZ80.f|=0x40;

			if (myZ80.a>0x7f)
				myZ80.f|=0x80;

			myZ80.pc++; 
		} break; //SUB A,d
	case 0x93: 
		{
			nResult;
			nResult=myZ80.a - (myZ80.de & 0x00ff);
			myZ80.f=0x02; //clear all flags, set N flag.
			myZ80.a=(nResult & 0xff);
			
			if (nResult <0x00)
				myZ80.f|=0x01; //set S and C flags

			if (myZ80.a==0x00)
				myZ80.f|=0x40;

			if (myZ80.a>0x7f)
				myZ80.f|=0x80;

			myZ80.pc++; 
		} break; //SUB A,e

	case 0x94: 
		{
			nResult;
			nResult=myZ80.a - ((myZ80.hl & 0xff00)>>8);
			myZ80.f=0x02; //clear all flags, set N flag.
			myZ80.a=(nResult & 0xff);
			
			if (nResult <0x00)
				myZ80.f|=0x01; //set S and C flags

			if (myZ80.a==0x00)
				myZ80.f|=0x40;

			if (myZ80.a>0x7f)
				myZ80.f|=0x80;

			myZ80.pc++; 
		} break; //SUB A,B
	case 0x95: 
		{
			nResult;
			nResult=myZ80.a - (myZ80.hl & 0x00ff);
			myZ80.f=0x02; //clear all flags, set N flag.
			myZ80.a=(nResult & 0xff);
			
			if (nResult <0x00)
				myZ80.f|=0x01; //set S and C flags

			if (myZ80.a==0x00)
				myZ80.f|=0x40;

			if (myZ80.a>0x7f)
				myZ80.f|=0x80;

			myZ80.pc++; 
		} break; //SUB A,c

	case 0x96: 
		{
			nResult=myZ80.a-Memory[myZ80.hl];
			myZ80.a=nResult & 0xff;
			myZ80.f=0x02; //set N flag

			if (myZ80.a==0x00) //chgeck/set Z flag
				myZ80.f |= 0x40;

			if (myZ80.a>0x7f) //check set S flag
				myZ80.f |= 0x80;

			if (nResult <0)
				myZ80.f |=0x01;	//check set CF

			myZ80.pc++; 
		} break; 

	case 0x97: {myZ80.a=0x00;myZ80.f=0x42;myZ80.pc++; } break; //SUB A,A

	case 0x98: 
		{
			nResult=myZ80.a-((myZ80.bc & 0xff00)>>8);
			nResult-=(myZ80.f & 0x01);
			myZ80.a=nResult&0xff;
			myZ80.f=0x02; //set N flag

			if (myZ80.a==0x00) //chgeck/set Z flag
				myZ80.f |= 0x40;

			if (myZ80.a>0x7f) //check set S flag
				myZ80.f |= 0x80;

			if (nResult < 0)
				myZ80.f |=0x01;	//check set CF

			myZ80.pc++; 
		} break; //SBC A,B
	case 0x99: 
		{
			nResult=myZ80.a-(myZ80.bc & 0x00ff);
			nResult-=(myZ80.f&0x01);
			myZ80.a=nResult&0xff;
			
			myZ80.f=0x02; //set N flag

			if (myZ80.a==0x00) //chgeck/set Z flag
				myZ80.f |= 0x40;

			if (myZ80.a>0x7f) //check set S flag
				myZ80.f |= 0x80;

			if (nResult < 0)
				myZ80.f |=0x01;	//check set CF

			myZ80.pc++; 
		} break; //SBC A,c
	case 0x9a: 
		{
			nResult=myZ80.a-((myZ80.de & 0xff00)>>8);
			nResult-=(myZ80.f&0x01);
			myZ80.a=nResult&0xff;
			
			myZ80.f=0x02; //set N flag

			if (myZ80.a==0x00) //chgeck/set Z flag
				myZ80.f |= 0x40;

			if (myZ80.a>0x7f) //check set S flag
				myZ80.f |= 0x80;

			if (nResult < 0)
				myZ80.f |=0x01;	//check set CF

			myZ80.pc++; 
		} break; //SBC A,B
	case 0x9b: 
		{
			nResult=myZ80.a-(myZ80.de & 0x00ff);
			nResult-=(myZ80.f&0x01);
			myZ80.a=nResult&0xff;
			
			myZ80.f=0x02; //set N flag

			if (myZ80.a==0x00) //chgeck/set Z flag
				myZ80.f |= 0x40;

			if (myZ80.a>0x7f) //check set S flag
				myZ80.f |= 0x80;

			if (nResult < 0)
				myZ80.f |=0x01;	//check set CF

			myZ80.pc++; 
		} break; //SBC A,c
	case 0x9c: 
		{
			nResult=myZ80.a-((myZ80.hl & 0xff00)>>8);
			nResult-=(myZ80.f&0x01);
			myZ80.a=nResult&0xff;
			
			myZ80.f=0x02; //set N flag

			if (myZ80.a==0x00) //chgeck/set Z flag
				myZ80.f |= 0x40;

			if (myZ80.a>0x7f) //check set S flag
				myZ80.f |= 0x80;

			if (nResult < 0)
				myZ80.f |=0x01;	//check set CF

			myZ80.pc++; 
		} break; //SBC A,B
	case 0x9d: 
		{
			nResult=myZ80.a-(myZ80.hl & 0x00ff);
			nResult-=(myZ80.f&0x01);
			myZ80.a=nResult&0xff;
			
			myZ80.f=0x02; //set N flag

			if (myZ80.a==0x00) //chgeck/set Z flag
				myZ80.f |= 0x40;

			if (myZ80.a>0x7f) //check set S flag
				myZ80.f |= 0x80;

			if (nResult < 0)
				myZ80.f |=0x01;	//check set CF

			myZ80.pc++; 
		} break; //SBC A,c

	
	
	case 0x9e: 		
		{
			nResult=(myZ80.a-(Memory[myZ80.hl]))-(myZ80.f & 0x01);
			myZ80.a=nResult&0xff;
			myZ80.f=0x02; //set N flag

			if (myZ80.a==0x00) //chgeck/set Z flag
				myZ80.f |= 0x40;

			if (myZ80.a>0x7f) //check set S flag
				myZ80.f |= 0x80;

			if (nResult < 0)
				myZ80.f |=0x01;	//check set CF

			myZ80.pc++; 
		} break; //SBC A,(hl)


	case 0x9f: 
		{
			myZ80.a=0x00;
			myZ80.a-=(myZ80.f & 0x01);
			if (myZ80.a==0x00) //chgeck/set Z flag
				myZ80.f |= 0x40;

			if (myZ80.a>0x7f) //check set S flag
				myZ80.f |= 0x80;

			myZ80.pc++; 
		} break;

	case 0xa0: 
		{
			myZ80.a &= ((myZ80.bc & 0xff00) >>8); // AND A,B
			myZ80.f=0x10; //rest all flags - set H flag

			if (Parity[myZ80.a])
				myZ80.f|=0x04;		//set PF for even parity.
			if (myZ80.a==00)
				myZ80.f|=0x40;		//set Z flag
			if (myZ80.a>0x7f)		//check/set S flag
				myZ80.f |= 0x80;
			myZ80.pc++; 
		} break; //AND B

	case 0xa1: 
		{
			myZ80.a &= (myZ80.bc & 0x00ff) ;
			myZ80.f=0x10; //rest all flags - set H flag

			if (Parity[myZ80.a])
				myZ80.f|=0x04;		//set PF for even parity.
			if (myZ80.a==00)
				myZ80.f|=0x40;		//set Z flag
			if (myZ80.a>0x7f)		//check/set S flag
				myZ80.f |= 0x80;
			myZ80.pc++; 
		} break; //AND C
	case 0xa2: 
		{
			myZ80.a &= ((myZ80.de & 0xff00) >>8); // AND A,B
			myZ80.f=0x10; //rest all flags - set H flag

			if (Parity[myZ80.a])
				myZ80.f|=0x04;		//set PF for even parity.
			if (myZ80.a==00)
				myZ80.f|=0x40;		//set Z flag
			if (myZ80.a>0x7f)		//check/set S flag
				myZ80.f |= 0x80;
			myZ80.pc++; 
		} break; //AND d

	case 0xa3: 
		{
			myZ80.a &= (myZ80.de & 0x00ff) ;
			myZ80.f=0x10; //rest all flags - set H flag

			if (Parity[myZ80.a])
				myZ80.f|=0x04;		//set PF for even parity.
			if (myZ80.a==00)
				myZ80.f|=0x40;		//set Z flag
			if (myZ80.a>0x7f)		//check/set S flag
				myZ80.f |= 0x80;
			myZ80.pc++; 
		} break; //AND e
	case 0xa4: 
		{
			myZ80.a &= ((myZ80.hl & 0xff00) >>8); // AND A,B
			myZ80.f=0x10; //rest all flags - set H flag

			if (Parity[myZ80.a])
				myZ80.f|=0x04;		//set PF for even parity.
			if (myZ80.a==00)
				myZ80.f|=0x40;		//set Z flag
			if (myZ80.a>0x7f)		//check/set S flag
				myZ80.f |= 0x80;
			myZ80.pc++; 
		} break; //AND h

	case 0xa5: 
		{
			myZ80.a &= (myZ80.hl & 0x00ff) ;
			myZ80.f=0x10; //rest all flags - set H flag

			if (Parity[myZ80.a])
				myZ80.f|=0x04;		//set PF for even parity.
			if (myZ80.a==00)
				myZ80.f|=0x40;		//set Z flag
			if (myZ80.a>0x7f)		//check/set S flag
				myZ80.f |= 0x80;
			myZ80.pc++; 
		} break; //AND l

	case 0xa6: 
		{
			myZ80.a &= Memory[myZ80.hl] ;
			myZ80.f=0x10; //rest all flags - set H flag

			if (Parity[myZ80.a])
				myZ80.f|=0x04;		//set PF for even parity.
			if (myZ80.a==00)
				myZ80.f|=0x40;		//set Z flag
			if (myZ80.a>0x7f)		//check/set S flag
				myZ80.f |= 0x80;
			myZ80.pc++; 
		} break; //AND (hl)

	case 0xa7: 
		{
			myZ80.f=0x10; //rest all flags - set H flag

			if (Parity[myZ80.a])
				myZ80.f|=0x04;		//set PF for even parity.
			if (myZ80.a==00)
				myZ80.f|=0x40;		//set Z flag
			if (myZ80.a>0x7f)		//check/set S flag
				myZ80.f |= 0x80;
			myZ80.pc++; 
		} break; //AND a

	case 0xa8: 
		{
			myZ80.a ^= ((myZ80.bc & 0xff00) >>8); // XOR A,B
			myZ80.f=0x00; //rest all flags - set H flag

			if (Parity[myZ80.a])
				myZ80.f|=0x04;		//set PF for even parity.
			if (myZ80.a==00)
				myZ80.f|=0x40;		//set Z flag
			if (myZ80.a>0x7f)		//check/set S flag
				myZ80.f |= 0x80;
			myZ80.pc++; 
		} break; //XOR B

	case 0xa9: 
		{
			myZ80.a ^= (myZ80.bc & 0x00ff) ;
			myZ80.f=0x00; //rest all flags - set H flag

			if (Parity[myZ80.a])
				myZ80.f|=0x04;		//set PF for even parity.
			if (myZ80.a==00)
				myZ80.f|=0x40;		//set Z flag
			if (myZ80.a>0x7f)		//check/set S flag
				myZ80.f |= 0x80;
			myZ80.pc++; 
		} break; //xor C
	case 0xaa: 
		{
			myZ80.a ^= ((myZ80.de & 0xff00) >>8); // AND A,B
			myZ80.f=0x00; //rest all flags - set H flag

			if (Parity[myZ80.a])
				myZ80.f|=0x04;		//set PF for even parity.
			if (myZ80.a==00)
				myZ80.f|=0x40;		//set Z flag
			if (myZ80.a>0x7f)		//check/set S flag
				myZ80.f |= 0x80;
			myZ80.pc++; 
		} break; //AND d

	case 0xab: 
		{
			myZ80.a ^= (myZ80.de & 0x00ff) ;
			myZ80.f=0x00; //rest all flags - set H flag

			if (Parity[myZ80.a])
				myZ80.f|=0x04;		//set PF for even parity.
			if (myZ80.a==00)
				myZ80.f|=0x40;		//set Z flag
			if (myZ80.a>0x7f)		//check/set S flag
				myZ80.f |= 0x80;
			myZ80.pc++; 
		} break; //AND e
	case 0xac: 
		{
			myZ80.a ^= ((myZ80.hl & 0xff00) >>8); // AND A,B
			myZ80.f=0x00; //rest all flags - set H flag

			if (Parity[myZ80.a])
				myZ80.f|=0x04;		//set PF for even parity.
			if (myZ80.a==00)
				myZ80.f|=0x40;		//set Z flag
			if (myZ80.a>0x7f)		//check/set S flag
				myZ80.f |= 0x80;
			myZ80.pc++; 
		} break; //AND h

	case 0xad: 
		{
			myZ80.a ^= (myZ80.hl & 0x00ff) ;
			myZ80.f=0x00; //rest all flags - set H flag

			if (Parity[myZ80.a])
				myZ80.f|=0x04;		//set PF for even parity.
			if (myZ80.a==00)
				myZ80.f|=0x40;		//set Z flag
			if (myZ80.a>0x7f)		//check/set S flag
				myZ80.f |= 0x80;
			myZ80.pc++; 
		} break; //AND l

	case 0xae: 
		{
			myZ80.a ^= Memory[myZ80.hl] ;
			myZ80.f=0x00; //rest all flags - set H flag

			if (Parity[myZ80.a])
				myZ80.f|=0x04;		//set PF for even parity.
			if (myZ80.a==00)
				myZ80.f|=0x40;		//set Z flag
			if (myZ80.a>0x7f)		//check/set S flag
				myZ80.f |= 0x80;
			myZ80.pc++; 
		} break; //AND (hl)

	case 0xaf: 
		{
			myZ80.a = 0 ;
			myZ80.f=0x40; //rest all flags - set Z flag

			myZ80.pc++; 
		} break; //xor a

	case 0xb0: 
		{
			myZ80.a |= ((myZ80.bc & 0xff00) >>8); // OR A,B
			myZ80.f=0x00; //rest all flags - set H flag

			if (Parity[myZ80.a])
				myZ80.f|=0x04;		//set PF for even parity.
			if (myZ80.a==00)
				myZ80.f|=0x40;		//set Z flag
			if (myZ80.a>0x7f)		//check/set S flag
				myZ80.f |= 0x80;
			myZ80.pc++; 
		} break; //OR B

	case 0xb1: 
		{
			myZ80.a |= (myZ80.bc & 0x00ff) ;
			myZ80.f=0x00; //rest all flags 

			if (Parity[myZ80.a])
				myZ80.f|=0x04;		//set PF for even parity.
			
			if (myZ80.a==00)
				myZ80.f|=0x40;		//set Z flag
			
			if (myZ80.a>0x7f)		//check/set S flag
				myZ80.f |= 0x80;

			myZ80.pc++; 
		} break; //or C
	case 0xb2: 
		{
			myZ80.a |= ((myZ80.de & 0xff00) >>8); // or A,d
			myZ80.f=0x00; //rest all flags - set H flag

			if (Parity[myZ80.a])
				myZ80.f|=0x04;		//set PF for even parity.
			if (myZ80.a==00)
				myZ80.f|=0x40;		//set Z flag
			if (myZ80.a>0x7f)		//check/set S flag
				myZ80.f |= 0x80;
			myZ80.pc++; 
		} break; //or d

	case 0xb3: 
		{
			myZ80.a |= (myZ80.de & 0x00ff) ;
			myZ80.f=0x00; //rest all flags - set H flag

			if (Parity[myZ80.a])
				myZ80.f|=0x04;		//set PF for even parity.
			if (myZ80.a==00)
				myZ80.f|=0x40;		//set Z flag
			if (myZ80.a>0x7f)		//check/set S flag
				myZ80.f |= 0x80;
			myZ80.pc++; 
		} break; //or e
	case 0xb4: 
		{
			myZ80.a |= ((myZ80.hl & 0xff00) >>8); // AND A,B
			myZ80.f=0x00; //rest all flags - set H flag

			if (Parity[myZ80.a])
				myZ80.f|=0x04;		//set PF for even parity.
			if (myZ80.a==00)
				myZ80.f|=0x40;		//set Z flag
			if (myZ80.a>0x7f)		//check/set S flag
				myZ80.f |= 0x80;
			myZ80.pc++; 
		} break; //or h

	case 0xb5: 
		{
			myZ80.a |= (myZ80.hl & 0x00ff) ;
			myZ80.f=0x00; //rest all flags - set H flag

			if (Parity[myZ80.a])
				myZ80.f|=0x04;		//set PF for even parity.
			if (myZ80.a==00)
				myZ80.f|=0x40;		//set Z flag
			if (myZ80.a>0x7f)		//check/set S flag
				myZ80.f |= 0x80;
			myZ80.pc++; 
		} break; //or l

	case 0xb6: 
		{
			myZ80.a |= Memory[myZ80.hl] ;
			myZ80.f=0x00; //rest all flags - set H flag

			if (Parity[myZ80.a])
				myZ80.f|=0x04;		//set PF for even parity.
			if (myZ80.a==00)
				myZ80.f|=0x40;		//set Z flag
			if (myZ80.a>0x7f)		//check/set S flag
				myZ80.f |= 0x80;
			myZ80.pc++; 
		} break; //or (hl)

	case 0xb7: 
		{
			myZ80.f=0x00; //rest all flags - set H flag

			if (Parity[myZ80.a])
				myZ80.f|=0x04;		//set PF for even parity.
			if (myZ80.a==00)
				myZ80.f|=0x40;		//set Z flag
			if (myZ80.a>0x7f)		//check/set S flag
				myZ80.f |= 0x80;
			myZ80.pc++; 
		} break; //or a
	case 0xb8: 
		{
			nResult=myZ80.a-((myZ80.bc &0xff00)>>8);
			myZ80.f=0x02; //reset all flags, set N flag
			if (nResult <0x00)
				myZ80.f |=0x81; //set CF and SF

			if (nResult==0)
				myZ80.f|=0x40; //set Z flag
			myZ80.pc++; 
		} break; //CP B
	case 0xb9: 
		{
			nResult=myZ80.a-(myZ80.bc &0x00ff);
			if (nResult <0x00)
				myZ80.f |=0x81; //set CF and SF

			if (nResult==0)
				myZ80.f|=0x40; //set Z flag

			myZ80.pc++; 
		} break; //CP C

	case 0xba: 
		{
			nResult=myZ80.a-((myZ80.de &0xff00)>>8);
			myZ80.f=0x02; //reset all flags, set N flag
			if (nResult <0x00)
				myZ80.f |=0x81; //set CF and SF

			if (nResult==0)
				myZ80.f|=0x40; //set Z flag
			myZ80.pc++; 
		} break; //CP D
	case 0xbb: 
		{
			nResult=myZ80.a-(myZ80.de &0x00ff);
			if (nResult <0x00)
				myZ80.f |=0x81; //set CF and SF

			if (nResult==0)
				myZ80.f|=0x40; //set Z flag

			myZ80.pc++; 
		} break; //CP E

	case 0xbc: 
		{
			nResult=myZ80.a-((myZ80.hl &0xff00)>>8);
			myZ80.f=0x02; //reset all flags, set N flag
			if (nResult <0x00)
				myZ80.f |=0x81; //set CF and SF

			if (nResult==0)
				myZ80.f|=0x40; //set Z flag
			myZ80.pc++; 
		} break; //CP h
	case 0xbd: 
		{
			nResult=myZ80.a-(myZ80.hl &0x00ff);
			if (nResult <0x00)
				myZ80.f |=0x81; //set CF and SF

			if (nResult==0)
				myZ80.f|=0x40; //set Z flag

			myZ80.pc++; 
		} break; //CP L


	case 0xbe: 
		{
			myZ80.f=0x02; //reset all flags, set N flag
			nResult=myZ80.a - Memory[myZ80.hl];
			if (nResult<0x00)
				myZ80.f |=0x81;

			if (nResult==0)
				myZ80.f |=0x40;

			if (nResult >0x7f)
				myZ80.f |=0x80;

			myZ80.pc++; 
		} break; //CP (hl)


	case 0xbf: //CP A
		{
			//This is all we have to do!
			myZ80.f=0x42; //set Z and N flags, clear all others
			myZ80.pc++; 
		} break;

	case 0xc0: // RET NZ
		{
			myZ80.pc++;
			if ((myZ80.f & 0x40) == 0x00) //if Z flag NOT SET
			{
				myZ80.pc=Memory[myZ80.sp];
				myZ80.sp++;
				myZ80.pc+= Memory[myZ80.sp]<<8;
				myZ80.sp++;
				if (bLogging)
				{
					strMsg.Format("RET NZ  TO %4x\r\n",myZ80.pc);
					cfLogFile.Write(strMsg.GetBuffer(132),strMsg.GetLength());
				}
			}
		} break;
	case 0xc1: //POP BC
		{
			myZ80.bc=Memory[myZ80.sp];
			myZ80.sp++;
			myZ80.bc+= Memory[myZ80.sp]<<8;
			myZ80.sp++;
			myZ80.pc++; 
		} break;
	case 0xc2: //JP NZ
		{
			if ((myZ80.f & 0x40) == 0x00) //if Z flag NOT SET
			{			
				nAddr = Memory[++myZ80.pc];
				nAddr += Memory[++myZ80.pc]<<8;
				myZ80.pc=nAddr;
				if (bLogging)
				{
					strMsg.Format("JMP NZ  %4x\r\n",myZ80.pc);
					cfLogFile.Write(strMsg.GetBuffer(132),strMsg.GetLength());
				}
			}else
			{
				myZ80.pc+=3;
			}

		} break; //JP NZ,nnnn
	case 0xc3: 
		{
			nAddr = Memory[++myZ80.pc];
			nAddr += Memory[++myZ80.pc]<<8;
			myZ80.pc=nAddr;
			if (bLogging)
			{
				strMsg.Format("JMP     %4x\r\n",myZ80.pc);
				cfLogFile.Write(strMsg.GetBuffer(132),strMsg.GetLength());
			}
		} break; //JP nnnn
	case 0xc4: //CALL NZ,nnnn
		{
			if ((myZ80.f & 0x40) == 0x00) //if Z flag NOT SET
			{
				nAddr=myZ80.pc+3; //the return address.
				Memory[--myZ80.sp]=(nAddr & 0xff00)>>8; //save return address MSB
				Memory[--myZ80.sp]=(nAddr & 0x00ff); //save return address LSB
				nAddr = Memory[++myZ80.pc];
				nAddr += Memory[++myZ80.pc]<<8;
				myZ80.pc=nAddr;
				if (bLogging)
				{
					strMsg.Format("CALL NZ  %4x\r\n",myZ80.pc);
					cfLogFile.Write(strMsg.GetBuffer(132),strMsg.GetLength());
				}
			}else
			{
				myZ80.pc+=3;
			}
		} break;

	case 0xc5: //PUSH BC
		{
			Memory[--myZ80.sp]=(myZ80.bc & 0xff00)>>8; //save return address MSB
			Memory[--myZ80.sp]=(myZ80.bc & 0x00ff); //save return address LSB
			myZ80.pc++; 
		} break;
	case 0xc6:  //add a,n
		{
			myZ80.pc++;
			nResult=myZ80.a+Memory[myZ80.pc];
			myZ80.a=nResult & 0x00ff; //restrict to 8 bits
			myZ80.f=0; //clear all flags

			if (myZ80.a==0x00) //chgeck/set Z flag
				myZ80.f |= 0x40;

			if (myZ80.a>0x7f) //check set S flag
				myZ80.f |= 0x80;

			if (nResult > 0x00ff)
				myZ80.f |= 0x01; //check and set CF

			myZ80.pc++; 
		} break;
	case 0xc7: // RST 0
		{
			nAddr=myZ80.pc+1; //the return address.
			Memory[--myZ80.sp]=(nAddr & 0xff00)>>8; //save return address MSB
			Memory[--myZ80.sp]=(nAddr & 0x00ff); //save return address LSB
			myZ80.pc=0x0000; //RESTART at PC.
		} break;

	case 0xc8: //RET Z
		{
			myZ80.pc++; //pre adjust PC
			if ((myZ80.f & 0x40)==0x40) //if ZF set, RET
			{
				myZ80.pc=Memory[myZ80.sp];
				myZ80.sp++;
				myZ80.pc+= (Memory[myZ80.sp]<<8);
				myZ80.sp++;
				if (bLogging)
				{
					strMsg.Format("RET Z   TO %4x\r\n",myZ80.pc);
					cfLogFile.Write(strMsg.GetBuffer(132),strMsg.GetLength());
				}

			}

			//else carry on

		} break;

	case 0xc9: //RET
		{
			myZ80.pc=Memory[myZ80.sp];
			myZ80.sp++;
			myZ80.pc+= (Memory[myZ80.sp]<<8);
			myZ80.sp++;
			DoEvents();
			if (bLogging)
			{
				strMsg.Format("RET     TO %4x\r\n",myZ80.pc);
				cfLogFile.Write(strMsg.GetBuffer(132),strMsg.GetLength());
			}
		} break;
	case 0xca: //JP Z
		{
			if ((myZ80.f & 0x40) == 0x40) //if Z flag SET
			{
				nAddr = Memory[++myZ80.pc];
				nAddr += Memory[++myZ80.pc]<<8;
				myZ80.pc=nAddr;
				if (bLogging)
				{
					strMsg.Format("JMP  Z  %4x\r\n",myZ80.pc);
					cfLogFile.Write(strMsg.GetBuffer(132),strMsg.GetLength());
				}

			}else
			{
				myZ80.pc+=3;
			}

		} break; 
	case 0xcb: //CB Extended opcodes.
		{
			myZ80.pc++; 
			switch (Memory[myZ80.pc])
			{
			case 0x0f:
				{
					
					UINT  c=(myZ80.a & 0x01); //Carried bit is bit 1 of Accumulator
					myZ80.a=((myZ80.a>>1) & 0x7f) + (c*0x80); // Rotate left and add carried bit
					myZ80.f&=0xc4; //reset H and N flags.
					myZ80.f|=c; // add carried bit.
					myZ80.pc++; 
				} break; //RRCA
			case 0x08:
				{
					UINT  c=(myZ80.bc & 0x0100)>>8; //Carried bit is bit 1 of specified register
					BYTE oldReg=(myZ80.bc & 0xff00)>>8; //get existing register.
					oldReg=((oldReg>>1) & 0x7f) + (c*0x80); // Rotate left and add carried bit
					myZ80.bc = (myZ80.bc & 0x00ff);
					myZ80.bc+= (oldReg<<8);


					myZ80.f&=0xc4; //reset H and N flags.
					myZ80.f|=c; // add carried bit.
					myZ80.pc++; 
				} break; //RRC B
			case 0x18:
				{
					UINT  c=(myZ80.f & 0x01); //Carried bit is CF
					UINT  c_=(myZ80.bc & 0x0100)>>8; //New CF is bit 0 of B


					BYTE oldReg=(myZ80.bc & 0xff00)>>8; //get existing register.
					oldReg=((oldReg>>1) & 0x7f) + (c*0x80); // Rotate left and add carried bit
					myZ80.bc = (myZ80.bc & 0x00ff);
					myZ80.bc+= (oldReg<<8);


					myZ80.f&=0xc4; //reset H and N flags.
					myZ80.f|=c_; // add carried bit.
					myZ80.pc++; 
				} break; //RR B

			case 0x1f: //RRA
				{

					//for RR A we do nothing except gobble up the CB byte.
					// This allows the processor to run the RRA instruction instead.
					
				} break;
			case 0x29:
				{
					//SRA C
					BYTE C=(myZ80.bc & 0x00ff);
					BYTE CF=(C & 0x01);
					BYTE BIT7=(C & 0x80);
					C=C>>1;
					C+=BIT7;
					myZ80.bc&=0xff00; //clear c
					myZ80.bc+=C ; //add back new C register.
					myZ80.f=0x00 ; //rest all flags 
					myZ80.f|=CF; //set CF if required.
					if (C==0)
						myZ80.f|=0x40;
					if (C>0x7f)
						myZ80.f|=0x80;

				} break;
			case 0x40:
				{
					myZ80.f|=0x50; //set H and Z flag.
					myZ80.f&=0xfd; //reset N flag.
					if ((myZ80.bc & 0xff00) & 0x0100)
						myZ80.f &= 0xbf; // RESET Z flag
				} break;

			case 0x67: //bit 4,A
				{
					myZ80.f&=0x01; //reset every flag except CF
					myZ80.f|=0x10; //set H

					if ((myZ80.a&0x10)==0x00) //if bit 4 is not SET
						myZ80.f |= 0x40; // SET Z flag

				} break;
			case 0x6f: //bit 5,A
				{
					myZ80.f&=0x01; //reset every flag except CF
					myZ80.f|=0x10; //set H

					if ((myZ80.a&0x20)==0x00) //if bit 5 is not SET
						myZ80.f |= 0x40; // SET Z flag

				} break;


			default:
				{
					CString strMsg;
					strMsg.Format("Unhandled Z80 instruction (CB %2x) at %4x.",Memory[myZ80.pc],myZ80.pc);
					AfxMessageBox(strMsg);
					myZ80.pc++; 	
				} break;
				
			}
		} break;
	case 0xcc: //CALL Z,nnnn
		{
			if ((myZ80.f & 0x40) == 0x40) //if Z flag SET
			{
				nAddr=myZ80.pc+3; //the return address.
				myZ80.sp--;
				Memory[myZ80.sp]=(nAddr & 0xff00)>>8; //save return address MSB
				myZ80.sp--;
				Memory[myZ80.sp]=(nAddr & 0x00ff); //save return address LSB
				nAddr = Memory[++myZ80.pc];
				nAddr += Memory[++myZ80.pc]<<8;
				myZ80.pc=nAddr;
				if (bLogging)
				{
					strMsg.Format("CALL Z  %4x\r\n",myZ80.pc);
					cfLogFile.Write(strMsg.GetBuffer(132),strMsg.GetLength());
				}
			}else
			{
				myZ80.pc+=3;
			}
		} break;

	case 0xcd: //call nnnn
		{
			nAddr=myZ80.pc+3; //the return address.
			Memory[--myZ80.sp]=((nAddr & 0xff00)>>8); //save return address MSB
			Memory[--myZ80.sp]=(nAddr & 0x00ff); //save return address LSB
			nAddr = Memory[++myZ80.pc]; //the CALL address
			nAddr += Memory[++myZ80.pc]<<8;
			myZ80.pc=nAddr;
/*#ifdef _DEBUG
			if (myZ80.pc==0x1675)
				{
					OnDebugLogToFile();
					AfxMessageBox("Log on");
				}
#endif */
			if (bLogging)
			{
					
				strMsg.Format("CALL %4x\r\n",myZ80.pc);
				cfLogFile.Write(strMsg.GetBuffer(132),strMsg.GetLength());
			}
		} break;
	case 0xce: 
		{
			UINT nResult;
			myZ80.pc++;
			myZ80.f=0x00; //reset all flags
			
			nResult=myZ80.a+Memory[myZ80.pc];
			nResult+=(myZ80.f & 0x01);
			if (nResult > 0xff)
				myZ80.f|=0x04;
			
			myZ80.a=nResult & 0xff;

			if (myZ80.a==00)
				myZ80.f|=0x40;		//set Z flag
			if (myZ80.a>0x7f)		//check/set S flag
				myZ80.f |= 0x80;
			if (nResult >0xff)
				myZ80.f|=0x01;

			myZ80.pc++; 
		} break;
	case 0xcf: //RST 8
		{
			nAddr=myZ80.pc+1; //the return address.
			Memory[--myZ80.sp]=(nAddr & 0xff00)>>8; //save return address MSB
			Memory[--myZ80.sp]=(nAddr & 0x00ff); //save return address LSB
			myZ80.pc=0x0008; //RESTART at PC.
		}   break;


	case 0xd0: //RET nc
		{
			myZ80.pc++; //pre adjust PC
			if ((myZ80.f & 0x01) == 0x00) //if C not set, RET
			{
				myZ80.pc=Memory[myZ80.sp];
				myZ80.sp++;
				myZ80.pc+= Memory[myZ80.sp]<<8;
				myZ80.sp++;
				if (bLogging)
				{
					strMsg.Format("RET NC  TO %4x\r\n",myZ80.pc);
					cfLogFile.Write(strMsg.GetBuffer(132),strMsg.GetLength());
				}

			}//else carry on

		} break;

	case 0xd1: //pop de
		{
			myZ80.de=Memory[myZ80.sp];
			myZ80.sp++;
			myZ80.de+= Memory[myZ80.sp]<<8;
			myZ80.sp++;
			myZ80.pc++; 
		} break;
	case 0xd2://JP Nc
		{
			if ((myZ80.f & 0x01) == 0x00) //if CF flag  not SET
			{
				nAddr = Memory[++myZ80.pc];
				nAddr += Memory[++myZ80.pc]<<8;
				myZ80.pc=nAddr;
				if (bLogging)
				{
					strMsg.Format("JMP  NC %4x\r\n",myZ80.pc);
					cfLogFile.Write(strMsg.GetBuffer(132),strMsg.GetLength());
				}

			}else
			{
				myZ80.pc+=3;
			}

		} break;
	case 0xd3: {myZ80.pc++;myZ80.pc++; } break; //OUT(nn),A
	case 0xd4: //CALL NC,nnnn
		{
			if ((myZ80.f & 0x01) == 0x00) //if CF flag NOT SET
			{
				nAddr=myZ80.pc+3; //the return address.
				Memory[--myZ80.sp]=(nAddr & 0xff00)>>8; //save return address MSB
				Memory[--myZ80.sp]=(nAddr & 0x00ff); //save return address LSB
				nAddr = Memory[++myZ80.pc];//the call address.
				nAddr += Memory[++myZ80.pc]<<8;
				myZ80.pc=nAddr;
				if (bLogging)
				{
					strMsg.Format("CALL NC %4x\r\n",myZ80.pc);
					cfLogFile.Write(strMsg.GetBuffer(132),strMsg.GetLength());
				}
			}else
			{
				myZ80.pc+=3;
			}
		} break;
	case 0xd5: //PUSH DE
		{
			Memory[--myZ80.sp]=(myZ80.de & 0xff00)>>8; //save return address MSB
			Memory[--myZ80.sp]=(myZ80.de & 0x00ff); //save return address LSB
			myZ80.pc++; 
		} break;

	case 0xd6: 
		{
			nResult;
			myZ80.pc++;
			nResult=myZ80.a - Memory[myZ80.pc];
			myZ80.f=0x02; //clear all flags, set N flag.
			myZ80.a=(nResult & 0xff);
			
			if (nResult <0x00)
				myZ80.f|=0x01; //set S and C flags

			if (myZ80.a==0x00)
				myZ80.f|=0x40;

			if (myZ80.a>0x7f)
				myZ80.f|=0x80;


			myZ80.pc++; 
		} break;
	case 0xd7: //rst 10
		{
			nAddr=myZ80.pc+1; //the return address.
			Memory[--myZ80.sp]=(nAddr & 0xff00)>>8; //save return address MSB
			Memory[--myZ80.sp]=(nAddr & 0x00ff); //save return address LSB
			myZ80.pc=0x0010; //RESTART at PC.
		} break;

	case 0xd8: //RET c
		{
			myZ80.pc++; //pre adjust PC
			if ((myZ80.f & 0x01) == 0x01) //if CF set, RET
			{
				myZ80.pc=Memory[myZ80.sp];
				myZ80.sp++;
				myZ80.pc+=(Memory[myZ80.sp]<<8);
				myZ80.sp++;
				if (bLogging)
				{
					strMsg.Format("RET C   TO %4x\r\n",myZ80.pc);
					cfLogFile.Write(strMsg.GetBuffer(132),strMsg.GetLength());
				}
			}

			//else carry on

		} break;

	case 0xd9: 
		{
			UINT BC,DE,HL;
			BC=myZ80.bc;
			DE=myZ80.de;
			HL=myZ80.hl;
			myZ80.bc=myZ80.bc_;
			myZ80.de=myZ80.de_;
			myZ80.hl=myZ80.hl_;
			myZ80.bc_=BC;
			myZ80.de_=DE;
			myZ80.hl_=HL;
			myZ80.pc++; 
		} break; //EXX
	case 0xda://JP C
		{
			if ((myZ80.f & 0x01) == 0x01) //if CF flag  not SET
			{
				nAddr = Memory[++myZ80.pc];
				nAddr += Memory[++myZ80.pc]<<8;
				myZ80.pc=nAddr;
				if (bLogging)
				{
					strMsg.Format("JMP  C  %4x\r\n",myZ80.pc);
					cfLogFile.Write(strMsg.GetBuffer(132),strMsg.GetLength());
				}
			}else
			{
				myZ80.pc+=3;
			}

		} break;
	case 0xdb: 
		{
			myZ80.pc++; 
			myZ80.a=IoSpace[Memory[myZ80.pc]];
			myZ80.pc++;
		} break; //IN A,(nn)
	case 0xdc: //CALL C,nnnn
		{
			if ((myZ80.f & 0x01) == 0x01) //if CF SET
			{
				nAddr=myZ80.pc+3; //the return address.
				Memory[--myZ80.sp]=(nAddr & 0xff00)>>8; //save return address MSB
				Memory[--myZ80.sp]=(nAddr & 0x00ff); //save return address LSB
				nAddr = Memory[++myZ80.pc];
				nAddr += Memory[++myZ80.pc]<<8;
				myZ80.pc=nAddr;
				if (bLogging)
				{
					strMsg.Format("CALL C  %4x\r\n",myZ80.pc);
					cfLogFile.Write(strMsg.GetBuffer(132),strMsg.GetLength());
				}

			}else
			{
				myZ80.pc+=3;
			}
		} break;
	case 0xdd:  //EXTENDED Opcode.
		{
			myZ80.pc++; 
			switch (Memory[myZ80.pc])
			{
			
			case 0x19: 
				{
					myZ80.ix=myZ80.AddPair(myZ80.ix,myZ80.de); 
					myZ80.pc++;
				} break; //add ix,de
			case 0x21: 
				{
					myZ80.ix=Memory[++myZ80.pc];
					myZ80.ix+=(Memory[++myZ80.pc]<<8);
					myZ80.pc++;
				} break; //LD HL,NNNN
			case 0x2a: 
				{
					myZ80.pc++;
					nAddr = Memory[myZ80.pc];
					myZ80.pc++;
					nAddr+=(Memory[myZ80.pc]<<8);
					myZ80.ix=Memory[nAddr];
					myZ80.ix+=(Memory[nAddr+1]<<8);
					myZ80.pc++; 
				} break; //LD IX,(nnnn) 
			case 0xe9: 
				{
					myZ80.pc=myZ80.ix;
					if (bLogging)
					{
						strMsg.Format("JMP (IX) %4x\r\n",myZ80.pc);
						cfLogFile.Write(strMsg.GetBuffer(132),strMsg.GetLength());
					}

				} break;
			case 0x7e: 
				{
					myZ80.pc++; 
					dd=Memory[myZ80.pc];
					myZ80.a=Memory[myZ80.ix + dd] ;
					myZ80.pc++; 
				} break; //ld a,(hl)
			default:
				{
					CString strMsg;
					strMsg.Format("Unhandled Z80 instruction (DD %2x) at %4x.",Memory[myZ80.pc],myZ80.pc);
					AfxMessageBox(strMsg);
					myZ80.pc++;
				} break;
			}
		} break;
	case 0xde: //sbc a,nn
		{
			nResult;
			myZ80.pc++;
			nResult=myZ80.a-Memory[myZ80.pc];
			nResult-=(myZ80.f & 0x01); //sub CF too.
			myZ80.f=0x02; //set N flag
			myZ80.a=nResult & 0x00ff;
			
			if (myZ80.a==0x00) //chgeck/set Z flag
				myZ80.f |= 0x40;

			if (myZ80.a>0x7f) //check set S flag
				myZ80.f |= 0x80;

			if (nResult < 0)
				myZ80.f |=0x01;	//check set CF

			myZ80.pc++; 
		} break;
	case 0xdf: //RST 18
		{
			nAddr=myZ80.pc+1; //the return address.
			Memory[--myZ80.sp]=(nAddr & 0xff00)>>8; //save return address MSB
			Memory[--myZ80.sp]=(nAddr & 0x00ff); //save return address LSB
			myZ80.pc=0x0018; //RESTART at PC.
		} break;


	case 0xe0: //RET PO
		{
			myZ80.pc++; //pre adjust PC
			if ((myZ80.f & 0x04) == 0x00) //if PE not set, RET
			{
				myZ80.pc=Memory[myZ80.sp];
				myZ80.sp++;
				myZ80.pc+= Memory[myZ80.sp]<<8;
				myZ80.sp++;
			}
			

			//else carry on

		} break;

	case 0xe1: //pop HL
		{
			myZ80.hl=Memory[myZ80.sp];
			myZ80.sp++;
			myZ80.hl+= Memory[myZ80.sp]<<8;
			myZ80.sp++;
			myZ80.pc++; 
		} break;

	case 0xe2://JP PO
		{
			if ((myZ80.f & 0x04) == 0x00) //if PE flag NOT SET
			{
				nAddr = Memory[++myZ80.pc];
				nAddr += Memory[++myZ80.pc]<<8;
				myZ80.pc=nAddr;
				if (bLogging)
				{
					strMsg.Format("JMP PO  %4x\r\n",myZ80.pc);
					cfLogFile.Write(strMsg.GetBuffer(132),strMsg.GetLength());
				}

			}else
			{
				myZ80.pc+=3;
			}

		} break; //JP NZ,nnnn
	case 0xe3: //ex (SP),HL
		{
			UINT HL;
			HL=myZ80.hl;
			myZ80.hl=Memory[myZ80.sp] & 0x00ff;
			myZ80.hl+=(Memory[myZ80.sp+1] <<8);
			Memory[myZ80.sp]=(HL &0x00ff);
			Memory[myZ80.sp+1]=((HL &0xff00)>>8);
			myZ80.pc++; 
		} break;
	case 0xe4: //call PO
		{
			if ((myZ80.f & 0x04) == 0x00) //if PE flag not SET
			{
				nAddr=myZ80.pc+3; //the return address.
				myZ80.sp--;
				Memory[myZ80.sp]=(nAddr & 0xff00)>>8; //save return address MSB
				myZ80.sp--;
				Memory[myZ80.sp]=(nAddr & 0x00ff); //save return address LSB
				nAddr = Memory[++myZ80.pc];
				nAddr += Memory[++myZ80.pc]<<8;
				myZ80.pc=nAddr;
				if (bLogging)
				{
					strMsg.Format("CALL Po %4x\r\n",myZ80.pc);
					cfLogFile.Write(strMsg.GetBuffer(132),strMsg.GetLength());
				}

			}else
			{
				myZ80.pc+=3;
			}
		} break;
	case 0xe5: //PUSH HL
		{
			Memory[--myZ80.sp]=(myZ80.hl & 0xff00)>>8; //save return address MSB
			Memory[--myZ80.sp]=(myZ80.hl & 0x00ff); //save return address LSB
			myZ80.pc++; 
		} break;

	case 0xe6: 
		{
			myZ80.f=0x10; //rest all flags - set H flag
			myZ80.pc++;  //pre adjust PC
			myZ80.a&=Memory[myZ80.pc];
			if (Parity[myZ80.a])
				myZ80.f|=0x04;		//set PF for even parity.
			if (myZ80.a==00)
				myZ80.f|=0x40;		//set Z flag
			if (myZ80.a>0x7f)		//check/set S flag
				myZ80.f |= 0x80;
			myZ80.pc++; 

		} break; //AND nn
	case 0xe7: //RST 20
		{
			nAddr=myZ80.pc+1; //the return address.
			Memory[--myZ80.sp]=(nAddr & 0xff00)>>8; //save return address MSB
			Memory[--myZ80.sp]=(nAddr & 0x00ff); //save return address LSB
			myZ80.pc=0x0020; //RESTART at PC.
		}break;

	case 0xe8: //RET PE
		{
			myZ80.pc++; //pre adjust PC
			if ((myZ80.f & 0x04) == 0x04) //if PE set, RET
			{
				myZ80.pc=Memory[myZ80.sp];
				myZ80.sp++;
				myZ80.pc+= Memory[myZ80.sp]<<8;
				myZ80.sp++;
				if (bLogging)
				{
					strMsg.Format("RET PE  TO %4x\r\n",myZ80.pc);
					cfLogFile.Write(strMsg.GetBuffer(132),strMsg.GetLength());
				}

			}
				
			//else carry on

		} break;

	case 0xe9: //JP (HL)
		{
			myZ80.pc=myZ80.hl;
			if (bLogging)
			{
				strMsg.Format("JMP (HL) %4x\r\n",myZ80.pc);
				cfLogFile.Write(strMsg.GetBuffer(132),strMsg.GetLength());
			}

		} break;
	case 0xea: 
		{
			if ((myZ80.f & 0x04) == 0x04) //if PE flag is SET
			{
				nAddr = Memory[++myZ80.pc];
				nAddr += Memory[++myZ80.pc]<<8;
				myZ80.pc=nAddr;
				if (bLogging)
				{
					strMsg.Format("JMP PE  %4x\r\n",myZ80.pc);
					cfLogFile.Write(strMsg.GetBuffer(132),strMsg.GetLength());
				}

			}else
			{
				myZ80.pc+=3;
			}
		} break;
	case 0xeb: 
		{
			UINT HL=myZ80.hl;
			myZ80.hl=myZ80.de;
			myZ80.de=HL;
			myZ80.pc++; 
		} break;
	case 0xec: 
		{
		if ((myZ80.f & 0x04) == 0x04) //if P flag SET
			{
				nAddr=myZ80.pc+3; //the return address.
				myZ80.sp--;
				Memory[myZ80.sp]=(nAddr & 0xff00)>>8; //save return address MSB
				myZ80.sp--;
				Memory[myZ80.sp]=(nAddr & 0x00ff); //save return address LSB
				nAddr = Memory[++myZ80.pc];
				nAddr += Memory[++myZ80.pc]<<8;
				myZ80.pc=nAddr;
				if (bLogging)
				{
					strMsg.Format("CALL PE  %4x\r\n",myZ80.pc);
					cfLogFile.Write(strMsg.GetBuffer(132),strMsg.GetLength());
				}

			}else
			{
				myZ80.pc+=3;
			}
		} break;
	case 0xed: //ED is an EXTENDED OPCODE.
		{
			BYTE nResult;
			myZ80.pc++; //skip past the ED opcode.
			switch (Memory[myZ80.pc])
			{
			case 0x40: //IN B,(C)
				{
					nResult=IoSpace[myZ80.bc];
					myZ80.bc&=0x00ff; //clear destination register
					myZ80.bc+=(nResult<<8); //add IO Value.
					myZ80.pc++;

				}break;
			case 0x42:
				{
					BYTE C=myZ80.f & 0x01;
					myZ80.hl-=myZ80.bc;
					myZ80.hl-=C;
					myZ80.hl&=0xffff;
					myZ80.f=0x02;
					if (myZ80.hl==0x00)
						myZ80.f|=0x40;
					if (myZ80.hl>=0x07fff)
						myZ80.f|=0x80;
				} break;
			case 0x43: 
			{
				nAddr = Memory[++myZ80.pc];
				nAddr += Memory[++myZ80.pc]<<8;
				
				Memory[nAddr]=( myZ80.bc & 0x00ff);
				nAddr++;
				Memory[nAddr]=((myZ80.bc & 0xff00)>>8);
				myZ80.pc++;
				
			} break; //LD (nnnn),bc
			case 0x48: //IN C,(C)	
				{
					nResult=IoSpace[myZ80.bc];
					myZ80.bc&=0xff00; //clear destination register
					myZ80.bc+=nResult; //add IO Value.
					myZ80.pc++;
					
				}break;
			case 0x4b: //LD BC,(nnnn);
				{
					myZ80.pc++;
					nAddr=Memory[myZ80.pc];
					myZ80.pc++;
					nAddr+=Memory[myZ80.pc]<<8;
					myZ80.bc=Memory[nAddr];
					myZ80.bc+=(Memory[nAddr+1]<<8);
					myZ80.pc++;
				} break;
			case 0x50: //IN D,(C)				
				{
					nResult=IoSpace[myZ80.bc];
					myZ80.de&=0x00ff; //clear destination register
					myZ80.de+=(nResult<<8); //add IO Value.
					myZ80.pc++;
					
				}break;
			case 0x52: //SBC HL,DE
				{
					BYTE C=myZ80.f & 0x01;
					myZ80.hl-=myZ80.de;
					myZ80.hl-=C;
					myZ80.hl&=0xffff;
					myZ80.f=0x02;
					if (myZ80.hl==0x00)
						myZ80.f|=0x40;
					if (myZ80.hl>=0x07fff)
						myZ80.f|=0x80;
				} break;
			case 0x53: 
			{
				nAddr = Memory[++myZ80.pc];
				nAddr += Memory[++myZ80.pc]<<8;
				
				Memory[nAddr]=( myZ80.de & 0x00ff);
				nAddr++;
				Memory[nAddr]=((myZ80.de & 0xff00)>>8) ;
				myZ80.pc++;
				
			} break; //LD (nnnn),de
			case 0x58: //IN E,(C)	
				{
					nResult=IoSpace[myZ80.bc];
					myZ80.de&=0xff00; //clear destination register
					myZ80.de+=nResult; //add IO Value.
					myZ80.pc++;
					
				}break;
			case 0x5b: //LD DE,(nnnn);
				{
					myZ80.pc++;
					nAddr=Memory[myZ80.pc];
					myZ80.pc++;
					nAddr+=Memory[myZ80.pc]<<8;
					myZ80.de=Memory[nAddr];
					myZ80.de+=(Memory[nAddr+1]<<8);
					myZ80.pc++;
				} break;
			case 0x5f: //LD A,R
				{
					myZ80.pc++;
					srand( (unsigned)time( NULL ) );
					myZ80.a= rand()&0xff;
				} break;
			case 0x60: //IN H,(C)				
				{
					nResult=IoSpace[myZ80.bc];
					myZ80.hl&=0x00ff; //clear destination register
					myZ80.hl+=(nResult<<8); //add IO Value.
					myZ80.pc++;
					
				}break;
			case 0x62: //SBC HL,HL
				{
					BYTE C=myZ80.f & 0x01;
					myZ80.hl=0x0000;
					myZ80.hl-=C;
					myZ80.hl&=0xffff;
					myZ80.f=0x02;
					if (myZ80.hl==0x00)
						myZ80.f|=0x40;
					if (myZ80.hl>=0x07fff)
						myZ80.f|=0x80;
				} break;
			case 0x63: 
			{
				nAddr = Memory[++myZ80.pc];
				nAddr += Memory[++myZ80.pc]<<8;
				
				Memory[nAddr]=( myZ80.hl & 0x00ff);
				nAddr++;
				Memory[nAddr]=((myZ80.hl & 0xff00)>>8);
				myZ80.pc++;
				
			} break; //LD (nnnn),HL
			case 0x68: //IN L,(C)	
				{
					nResult=IoSpace[myZ80.bc];
					myZ80.hl&=0xff00; //clear destination register
					myZ80.hl+=nResult; //add IO Value.
					myZ80.pc++;
					
				}break;
			case 0x6b: //LD HL,(nnnn);
				{
					myZ80.pc++;
					nAddr=Memory[myZ80.pc];
					myZ80.pc++;
					nAddr+=Memory[myZ80.pc]<<8;
					myZ80.hl=Memory[nAddr];
					myZ80.hl+=(Memory[nAddr+1]<<8);
					myZ80.pc++;
				} break;
			case 0x70: //IN C,(C)				
				{
					nResult=IoSpace[myZ80.bc];
					myZ80.bc&=0xff00; //clear destination register
					myZ80.bc+=(nResult); //add IO Value.
					myZ80.pc++;
					
				}break;
			case 0x72: //SBC HL,SP
				{
					BYTE C=myZ80.f & 0x01;
					myZ80.hl-=myZ80.sp;
					myZ80.hl-=C;
					myZ80.hl&=0xffff;
					myZ80.f=0x02;
					if (myZ80.hl==0x00)
						myZ80.f|=0x40;
					if (myZ80.hl>=0x07fff)
						myZ80.f|=0x80;
				} break;
			case 0x73: 
			{
				nAddr = Memory[++myZ80.pc];
				nAddr += Memory[++myZ80.pc]<<8;
				
				Memory[nAddr]=( myZ80.sp & 0x00ff);
				nAddr++;
				Memory[nAddr]=((myZ80.sp & 0xff00)>>8);
				myZ80.pc++;
				
			} break; //LD (nnnn),sp
			case 0x78: //IN A,(C)
				{
					myZ80.a=IoSpace[myZ80.bc];
					myZ80.pc++;
				}break;
			case 0x7b: //LD SP,(nnnn);
				{
					myZ80.pc++;
					nAddr=Memory[myZ80.pc];
					myZ80.pc++;
					nAddr+=Memory[myZ80.pc]<<8;
					myZ80.sp=Memory[nAddr];
					myZ80.sp+=(Memory[nAddr+1]<<8);
					myZ80.pc++;
				} break;
			case 0xb0: //LDIR
				{

					while (myZ80.bc  != 0x0000)
					{
						Memory[myZ80.de]=Memory[myZ80.hl];
						myZ80.de=myZ80.IncPair(myZ80.de);
						myZ80.hl=myZ80.IncPair(myZ80.hl);
						myZ80.bc=myZ80.DecPair(myZ80.bc);
					}
					myZ80.pc++;
					
				}break;
			default:
				{
					CString strMsg;
					strMsg.Format("Unhandled Z80 instruction (ED %2x) at %4x.",Memory[myZ80.pc],myZ80.pc);
					AfxMessageBox(strMsg);
					myZ80.pc++;
				} break;
			}

		} break;
	case 0xee: 
		{
			myZ80.pc++; 
			myZ80.a ^= Memory[myZ80.pc];
			myZ80.f=0x00; //rest all flags -

			if (Parity[myZ80.a])
				myZ80.f|=0x04;		//set PF for even parity.
			if (myZ80.a==00)
				myZ80.f|=0x40;		//set Z flag
			if (myZ80.a>0x7f)		//check/set S flag
				myZ80.f |= 0x80;

			myZ80.pc++; 
		} break; //XOR nn
	case 0xef: 
		{
			nAddr=myZ80.pc+1; //the return address.
			Memory[--myZ80.sp]=(nAddr & 0xff00)>>8; //save return address MSB
			Memory[--myZ80.sp]=(nAddr & 0x00ff); //save return address LSB
			myZ80.pc=0x0028; //RESTART at PC.
		} break;


	case 0xf0: //RET P
		{
			myZ80.pc++; //pre adjust PC
			if ((myZ80.f & 0x80) == 0x00) //if S not set, RET
			{
				myZ80.pc=Memory[myZ80.sp];
				myZ80.sp++;
				myZ80.pc+= Memory[myZ80.sp]<<8;
				myZ80.sp++;
				if (bLogging)
				{
					strMsg.Format("RET P   TO %4x\r\n",myZ80.pc);
					cfLogFile.Write(strMsg.GetBuffer(132),strMsg.GetLength());
				}
			}

			//else carry on

		} break;

	case 0xf1: //pop AF
		{
			myZ80.f=Memory[myZ80.sp] ;
			myZ80.sp++;
			myZ80.a=Memory[myZ80.sp] ;
			myZ80.sp++;
			myZ80.pc++; 
		} break;

	case 0xf2: //JP p
		{
			if ((myZ80.f & 0x80) == 0x00) //if S flag is not SET
			{
				nAddr = Memory[++myZ80.pc];
				nAddr += Memory[++myZ80.pc]<<8;
				myZ80.pc=nAddr;
				if (bLogging)
				{
					strMsg.Format("JMP P   %4x\r\n",myZ80.pc);
					cfLogFile.Write(strMsg.GetBuffer(132),strMsg.GetLength());
				}

			}else
			{
				myZ80.pc+=3;
			}

		} break; //JP NZ,nnnn
	//case 0xf3: {myZ80.pc++; } break;//di
	case 0xf4: 
		{
			if ((myZ80.f & 0x80) == 0x00) //if S flag not SET
			{
				nAddr=myZ80.pc+3; //the return address.
				myZ80.sp--;
				Memory[myZ80.sp]=(nAddr & 0xff00)>>8; //save return address MSB
				myZ80.sp--;
				Memory[myZ80.sp]=(nAddr & 0x00ff); //save return address LSB
				nAddr = Memory[++myZ80.pc];
				nAddr += Memory[++myZ80.pc]<<8;
				myZ80.pc=nAddr;
				if (bLogging)
				{
					strMsg.Format("CALL P  %4x\r\n",myZ80.pc);
					cfLogFile.Write(strMsg.GetBuffer(132),strMsg.GetLength());
				}
			}else
			{
				myZ80.pc+=3;
			}
		} break;
	case 0xf5: //PUSH AF
		{
			Memory[--myZ80.sp]=(myZ80.a); //save return address MSB
			Memory[--myZ80.sp]=(myZ80.f); //save return address LSB
			myZ80.pc++; 
		} break;

	case 0xf6: 
		{
			myZ80.pc++;
			myZ80.a |= Memory[myZ80.pc] ;
			myZ80.f=0x00; //rest all flags - set H flag

			if (Parity[myZ80.a])
				myZ80.f|=0x04;		//set PF for even parity.
			if (myZ80.a==00)
				myZ80.f|=0x40;		//set Z flag
			if (myZ80.a>0x7f)		//check/set S flag
				myZ80.f |= 0x80;
			myZ80.pc++; 
		} break;
	case 0xf7: //RST 30h
		{
			nAddr=myZ80.pc+1; //the return address.
			Memory[--myZ80.sp]=(nAddr & 0xff00)>>8; //save return address MSB
			Memory[--myZ80.sp]=(nAddr & 0x00ff); //save return address LSB
			myZ80.pc=0x0030; //RESTART at PC.
		} break;

	case 0xf8: //RET M
		{
			myZ80.pc++; //pre adjust PC
			if ((myZ80.f & 0x80) == 0x80) //if M SET, RET
			{
				myZ80.pc=Memory[myZ80.sp];
				myZ80.sp++;
				myZ80.pc+= Memory[myZ80.sp]<<8;
				myZ80.sp++;
				if (bLogging)
				{
					strMsg.Format("RET M   TO %4x\r\n",myZ80.pc);
					cfLogFile.Write(strMsg.GetBuffer(132),strMsg.GetLength());
				}

			}

			//else carry on

		} break;

	case 0xf9: 
		{
			myZ80.sp=myZ80.hl;
			myZ80.pc++; 
		} break;
	case 0xfa: 
		{
			if ((myZ80.f & 0x80) == 0x80) //if SIGN (M) flag is SET.
			{
				nAddr = Memory[++myZ80.pc];
				nAddr += Memory[++myZ80.pc]<<8;
				myZ80.pc=nAddr;
				if (bLogging)
				{
					strMsg.Format("JMP  M  %4x\r\n",myZ80.pc);
					cfLogFile.Write(strMsg.GetBuffer(132),strMsg.GetLength());
				}

			}else
			{
				myZ80.pc+=3;
			}

		} break;
	//case 0xfb: {myZ80.pc++; } break;//ei
	case 0xfc: 
		{
			if ((myZ80.f & 0x80) == 0x80) //if S flag SET
			{
				nAddr=myZ80.pc + 3; //the return address.
				myZ80.sp--;
				Memory[myZ80.sp]=(nAddr & 0xff00)>>8; //save return address MSB
				myZ80.sp--;
				Memory[myZ80.sp]=(nAddr & 0x00ff); //save return address LSB
				nAddr = Memory[++myZ80.pc];
				nAddr += Memory[++myZ80.pc]<<8;
				myZ80.pc=nAddr;
				if (bLogging)
				{
					strMsg.Format("CALL M  %4x\r\n",myZ80.pc);
					cfLogFile.Write(strMsg.GetBuffer(132),strMsg.GetLength());
				}

			}else
			{
				myZ80.pc+=3;
			}
		} break;
	case 0xfd: 
		{
			CString strMsg;
			strMsg.Format("Unhandled Z80 instruction (FD %2x) at %4x.",Memory[myZ80.pc],myZ80.pc);
			AfxMessageBox(strMsg);
			myZ80.pc++; 
		} break;
	case 0xfe: 
		{
			nResult;
			myZ80.pc++;
			nResult = myZ80.a-Memory[myZ80.pc];
			myZ80.f=0x02; //set N flag, clear all other flags.
			if (nResult <0)
				myZ80.f |=0x85; //set S,V and C flags

			if (nResult==0)
				myZ80.f|=0x40;

			myZ80.pc++;
		} break;
	case 0xff: 
		{
			nAddr=myZ80.pc+1; //the return address.
			Memory[--myZ80.sp]=(nAddr & 0xff00)>>8; //save return address MSB
			Memory[--myZ80.sp]=(nAddr & 0x00ff); //save return address LSB
			myZ80.pc=0x0038; //RST 38
		} break;


	default:
		{
			strMsg.Format("Unhandled instruction %2x at %4x",Memory[myZ80.pc],myZ80.pc);
			AfxMessageBox(strMsg);
			myZ80.pc++;	
		}	break;
	}
	myZ80.pc &=0x00ffff; //restrict PC to 64K
	return TRUE;
}

void CAqEmuDlg::OnSize(UINT nType, int cx, int cy) 
{
	//nZoomX=(cx/320);
	//nZoomY=(cy/212);
	InvalidateRect(NULL,TRUE);
}

void CAqEmuDlg::OnProcessorReset() 
{
	myZ80.Reset();	//reset Z80 registers

	AqShiftKey=FALSE;
	AqCtrlKey=FALSE;


}

void CAqEmuDlg::OnLoadRom() 
{
	if (bRun)
	{
		AfxMessageBox("Can't load rom: Processor already running.\nPlease stop processor first.");
		return;
	}

	CFileException fileException;
	CString strLineBuffer, strError;
	char strChar;
	UINT i,len,nBytes;


	CString fileName;
	fileName="*.rom";

	CFileDialog dlg(TRUE,NULL,NULL,OFN_HIDEREADONLY|OFN_OVERWRITEPROMPT,
	_T("ROM Files (*.rom)|*.rom|All Files (*.*)|*.*||"),NULL);

	//initialize the file name box with a default value.
	dlg.m_ofn.lpstrFile = fileName.GetBuffer(_MAX_PATH);
	if (!(dlg.DoModal()==IDOK))
	{
		return;
	}

	strRomFileName=dlg.GetPathName();

	if ( !m_RomFile.Open( strRomFileName, CFile::modeRead , &fileException ))
	{
		strError.Format( "Can't open file %s, error = %u\n",strRomFileName, fileException.m_cause );
		AfxMessageBox(strError);
		return;
	}

	len=m_RomFile.GetLength(); //calculate length of file opened.
	if (len != 0x2000)
	{
		AfxMessageBox("ROM Image was not 8192 bytes.\n\nROM Image was not loaded.",MB_OK,MB_ICONINFORMATION);
		return;
	}

	for(i=0;i<len;i++)
	{
		//read one byte at a time
		nBytes=m_RomFile.Read(&strChar, 1);
		if (!nBytes==1) //if we didn't get exactly one byte.
			break;

		Memory[i]=strChar;
	}
	
	m_RomFile.Close();
	bRomLoaded=TRUE;
	myZ80.Reset();
	
}

void CAqEmuDlg::OnViewClearScreenRam() 
{
	
	for(int nX=0;nX<960;nX++)
	{
		Memory[AQ_SCREENTOP+nX] = (BYTE) 0x20;
	}
	
}

BOOL CAqEmuDlg::RunProc(UINT nStartAddr, UINT nStopAddr)
{
	if (!bRomLoaded)
	{
		AfxMessageBox("Cannot run: No ROM loaded.");
		bRun=FALSE;
		return FALSE;
	}
	
	bLooping=TRUE; //set the exucution flag.
	
	CString strMsg; //used for logging to text file.
	myZ80.pc=nStartAddr & 0x00ffff; //restrict PC address to valid range.
	while ((myZ80.pc != nStopAddr) && bRun)
	{
		if (bLogging)
		{
			strMsg.Format("PC:%4x, OP:%4x, A:%4x, F:%4x, BC:%4x, DE:%4x, HL %4x,SP:%4x\r\n",myZ80.pc,Memory[myZ80.pc],myZ80.a,myZ80.f,myZ80.bc,myZ80.de,myZ80.hl,myZ80.sp);
			cfLogFile.Write(strMsg.GetBuffer(132),strMsg.GetLength());

		}

		ExecuteInstruction();
#ifdef _DEBUG
		DoEvents(); //slow down execution during DEBUG mode only.
#endif

		lCount++; //increment count of instructions executed.		
	}
	bLooping=FALSE;	
	return TRUE;
}



void CAqEmuDlg::OnProcessorAdvanced() 
{
	CProcAdvanced dlg;
	dlg.m_AddrStart=nAddrStart&0xffff;
	dlg.m_AddrEnd=nAddrStop & 0xffff;

	if (dlg.DoModal()==IDOK)
	{
		nAddrStart=dlg.m_AddrStart&0xffff;
		nAddrStop=dlg.m_AddrEnd&0xffff;
		myZ80.pc=nAddrStart;
	}
}



void CAqEmuDlg::SetParity()
{

// This routine fills a 1x256 array with TRUE or FALSE depending
// on wether X is EEVN parity or not.
	int nBits,x,r;
	for (x=0; x<256; x++)
	{
		nBits=0;
		for (r=0;r<8;r++)
		{
			nBits+=((x>>r) & 0x01);
		}
		switch (nBits)
		{
		case 0:
			Parity[x]=TRUE;
			break;
		case 1:
			Parity[x]=FALSE;
			break;
		case 2:
			Parity[x]=TRUE;
			break;
		case 3:
			Parity[x]=FALSE;
			break;
		case 4:
			Parity[x]=TRUE;
			break;
		case 5:
			Parity[x]=FALSE;
			break;
		case 6:
			Parity[x]=TRUE;
			break;
		case 7:
			Parity[x]=FALSE;
			break;
		case 8:
			Parity[x]=TRUE;
			break;
		}
			
	}
}

void CAqEmuDlg::OnProcessorStart() 
{

	if (bRun)
		return;  //simple return if already running.

		bRun=TRUE;
		RunProc(nAddrStart,nAddrStop); //Run proc from StartAddress to EndAddress.
	
}

void CAqEmuDlg::OnDebugLogToFile() 
{
	if (bLogging)
		return; //simple return if we are already logging.

	CFileException fileException;
	CString strFileName,strError;
	strFileName="trace.log";

	if ( !cfLogFile.Open( strFileName.GetBuffer(99), CFile::modeWrite|CFile::modeCreate , &fileException ))
	{
		strError.Format( "Can't open file. Error = %u\n", fileException.m_cause );
		AfxMessageBox(strError);
		return;
	}

	bLogging=TRUE;
	strTrace="AQUARIUS Emulator. (C) Kenny Millar, 2000\r\n";
	cfLogFile.Write(strTrace.GetBuffer(132),strTrace.GetLength());
	
	strTrace="\r\nCurrent ROM file:" ;
	strTrace+= strRomFileName;
	strTrace+= "\r\n\r\n";
	cfLogFile.Write(strTrace.GetBuffer(132),strTrace.GetLength());
	
}

void CAqEmuDlg::OnDebugStoplogging() 
{
	if (bLogging)
	{
		cfLogFile.Close();
		bLogging=FALSE;	
	}
}

void CAqEmuDlg::OnCancel() 
{
}

void CAqEmuDlg::OnClose() 
{
	//Check if processor is still running.
	//If so, advise user to kill processor before exiting.
	if (bLooping)
	{
		AfxMessageBox("Can't exit, processor is still running.\nStop processor then exit.");
		return;
	}
	OnDebugStoplogging(); //stop logging too.
	CDialog::OnOK();
}

void CAqEmuDlg::OnFileExit() 
{
	OnClose();
}

void CAqEmuDlg::ZapIoSpace()
{
	for(int x=0x00;x<=(64*1024);x++)
	{
		IoSpace[x]=0xff; //Fill IOSpace with 0xff
	}

}

void CAqEmuDlg::OnDebugTest() 
{

//	AfxMessageBox("Reserved for developers use.");

	myZ80.a=0xff;
	myZ80.f=01;
	myZ80.bc=0x0200;
	strMsg.Format("BC: %4x A:%2x F:%2x",myZ80.bc,myZ80.a,myZ80.f);
	AfxMessageBox(strMsg);

			myZ80.a+=((myZ80.bc & 0xff00)>>8);
			myZ80.a+=(myZ80.f & 0x01); //add CF too.
			myZ80.f=0; //clear all flags
			if (myZ80.a==0x00) //chgeck/set Z flag
				myZ80.f |= 0x40;

			if (myZ80.a>0x7f) //check set S flag
				myZ80.f |= 0x80;
	strMsg.Format("BC: %4x A:%2x F:%2x",myZ80.bc,myZ80.a,myZ80.f);
	AfxMessageBox(strMsg);

}

void CAqEmuDlg::FillKeyTable()
{
	KeyBoard[0xbb]=0xfefe;
	KeyBoard[0x08]=0xfefd;
	KeyBoard[0xc0]=0xfefb;
	KeyBoard[0x0d]=0xfef7; 
	KeyBoard[0xba]=0xfeef;
	KeyBoard[0xbe]=0xfedf;

	KeyBoard[0xbd]=0xfdfe;
	KeyBoard[0xbf]=0xfdfd;
	KeyBoard['0']=0xfdfb;
	KeyBoard['P']=0xfdf7; 
	KeyBoard['L']=0xfdef;
	KeyBoard[0xbC]=0xfddf;


	KeyBoard['9']=0xfbfe;
	KeyBoard['O']=0xfbfd;
	KeyBoard['K']=0xfbfb;
	KeyBoard['M']=0xfbf7; 
	KeyBoard['N']=0xfbef;
	KeyBoard['J']=0xfbdf;

	
	KeyBoard['8']=0xf7fe;
	KeyBoard['I']=0xf7fd;
	KeyBoard['7']=0xf7fb;
	KeyBoard['U']=0xf7f7; 
	KeyBoard['H']=0xf7ef;
	KeyBoard['B']=0xf7df;
	
	KeyBoard['6']=0xeffe;
	KeyBoard['Y']=0xeffd;
	KeyBoard['G']=0xeffb;
	KeyBoard['V']=0xeff7; 
	KeyBoard['C']=0xefef;
	KeyBoard['F']=0xefdf;

	KeyBoard['5']=0xdffe;
	KeyBoard['T']=0xdffd;
	KeyBoard['4']=0xdffb;
	KeyBoard['R']=0xdff7; 
	KeyBoard['D']=0xdfef;
	KeyBoard['X']=0xdfdf;

	KeyBoard['3']=0xbffe;
	KeyBoard['E']=0xbffd;
	KeyBoard['S']=0xbffb;
	KeyBoard['Z']=0xbff7; 
	KeyBoard[' ']=0xbfef;
	KeyBoard['A']=0xbfdf;

	KeyBoard['2']=0x7ffe;
	KeyBoard['W']=0x7ffd;
	KeyBoard['1']=0x7ffb;
	KeyBoard['Q']=0x7ff7; 

}


